/* deb822.c generated by valac 0.56.8, the Vala compiler
 * generated from deb822.vala, do not modify */

/* Copyright (C) 2014 Canonical Ltd.
 * Author: Colin Watson <cjwatson@ubuntu.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Simple deb822-like file parsing. */

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib-object.h>
#include "click.h"

#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_io_channel_unref0(var) ((var == NULL) ? NULL : (var = (g_io_channel_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))

VALA_EXTERN GRegex* click_field_re;
GRegex* click_field_re = NULL;
VALA_EXTERN GRegex* click_blank_re;
GRegex* click_blank_re = NULL;

VALA_EXTERN GeeMap* click_parse_deb822_file (const gchar* path,
                                 GError** error);

/**
 * parse_deb822_file:
 * @path: Path to a file.
 *
 * A very simple deb822-like file parser.
 *
 * Note that this only supports a single paragraph composed only of simple
 * (non-folded/multiline) fields, which is fortunately all we need in Click.
 *
 * Returns: A mapping of field names to values.
 */
GeeMap*
click_parse_deb822_file (const gchar* path,
                         GError** error)
{
	GRegex* _tmp0_;
	GRegex* _tmp4_;
	GeeHashMap* ret = NULL;
	GeeHashMap* _tmp8_;
	GIOChannel* channel = NULL;
	GIOChannel* _tmp9_;
	gchar* line = NULL;
	GError* _inner_error0_ = NULL;
	GeeMap* result;
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = click_field_re;
	if (_tmp0_ == NULL) {
		GRegex* _tmp1_ = NULL;
		GRegex* _tmp2_;
		GRegex* _tmp3_;
		_tmp2_ = g_regex_new ("^([^:[:space:]]+)[[:space:]]*:[[:space:]]" "([^[:space:]].*?)[[:space:]]*$", 0, 0, &_inner_error0_);
		_tmp1_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		}
		_tmp3_ = _tmp1_;
		_tmp1_ = NULL;
		_g_regex_unref0 (click_field_re);
		click_field_re = _tmp3_;
		_g_regex_unref0 (_tmp1_);
	}
	_tmp4_ = click_blank_re;
	if (_tmp4_ == NULL) {
		GRegex* _tmp5_ = NULL;
		GRegex* _tmp6_;
		GRegex* _tmp7_;
		_tmp6_ = g_regex_new ("^[[:space:]]*$", 0, 0, &_inner_error0_);
		_tmp5_ = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		}
		_tmp7_ = _tmp5_;
		_tmp5_ = NULL;
		_g_regex_unref0 (click_blank_re);
		click_blank_re = _tmp7_;
		_g_regex_unref0 (_tmp5_);
	}
	_tmp8_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	ret = _tmp8_;
	_tmp9_ = g_io_channel_new_file (path, "r", &_inner_error0_);
	channel = _tmp9_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (ret);
		return NULL;
	}
	while (TRUE) {
		gboolean _tmp10_ = FALSE;
		GIOStatus _tmp11_ = 0;
		GIOChannel* _tmp12_;
		gchar* _tmp13_ = NULL;
		GIOStatus _tmp14_;
		GMatchInfo* match_info = NULL;
		GRegex* _tmp16_;
		const gchar* _tmp17_;
		GRegex* _tmp18_;
		const gchar* _tmp19_;
		GMatchInfo* _tmp20_ = NULL;
		gboolean _tmp21_;
		_tmp12_ = channel;
		_tmp14_ = g_io_channel_read_line (_tmp12_, &_tmp13_, NULL, NULL, &_inner_error0_);
		_g_free0 (line);
		line = _tmp13_;
		_tmp11_ = _tmp14_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (line);
			_g_io_channel_unref0 (channel);
			_g_object_unref0 (ret);
			return NULL;
		}
		if (_tmp11_ == G_IO_STATUS_NORMAL) {
			const gchar* _tmp15_;
			_tmp15_ = line;
			_tmp10_ = _tmp15_ != NULL;
		} else {
			_tmp10_ = FALSE;
		}
		if (!_tmp10_) {
			break;
		}
		_tmp16_ = click_blank_re;
		_tmp17_ = line;
		if (g_regex_match (_tmp16_, _tmp17_, 0, NULL)) {
			_g_match_info_unref0 (match_info);
			break;
		}
		_tmp18_ = click_field_re;
		_tmp19_ = line;
		_tmp21_ = g_regex_match (_tmp18_, _tmp19_, 0, &_tmp20_);
		_g_match_info_unref0 (match_info);
		match_info = _tmp20_;
		if (_tmp21_) {
			gchar* key = NULL;
			GMatchInfo* _tmp22_;
			gchar* _tmp23_;
			gchar* value = NULL;
			GMatchInfo* _tmp24_;
			gchar* _tmp25_;
			gboolean _tmp26_ = FALSE;
			const gchar* _tmp27_;
			_tmp22_ = match_info;
			_tmp23_ = g_match_info_fetch (_tmp22_, 1);
			key = _tmp23_;
			_tmp24_ = match_info;
			_tmp25_ = g_match_info_fetch (_tmp24_, 2);
			value = _tmp25_;
			_tmp27_ = key;
			if (_tmp27_ != NULL) {
				const gchar* _tmp28_;
				_tmp28_ = value;
				_tmp26_ = _tmp28_ != NULL;
			} else {
				_tmp26_ = FALSE;
			}
			if (_tmp26_) {
				GeeHashMap* _tmp29_;
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				const gchar* _tmp33_;
				_tmp29_ = ret;
				_tmp30_ = key;
				_tmp31_ = g_utf8_strdown (_tmp30_, (gssize) -1);
				_tmp32_ = _tmp31_;
				_tmp33_ = value;
				gee_abstract_map_set ((GeeAbstractMap*) _tmp29_, _tmp32_, _tmp33_);
				_g_free0 (_tmp32_);
			}
			_g_free0 (value);
			_g_free0 (key);
		}
		_g_match_info_unref0 (match_info);
	}
	result = (GeeMap*) ret;
	_g_free0 (line);
	_g_io_channel_unref0 (channel);
	return result;
}

