/* framework.c generated by valac 0.56.8, the Vala compiler
 * generated from framework.vala, do not modify */

/* Copyright (C) 2014 Canonical Ltd.
 * Author: Colin Watson <cjwatson@ubuntu.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Click frameworks. */

#include "click.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>

enum  {
	CLICK_FRAMEWORK_0_PROPERTY,
	CLICK_FRAMEWORK_NAME_PROPERTY,
	CLICK_FRAMEWORK_NUM_PROPERTIES
};
static GParamSpec* click_framework_properties[CLICK_FRAMEWORK_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define CLICK_DIR_TYPE_ITERATOR (click_dir_iterator_get_type ())
#define CLICK_DIR_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLICK_DIR_TYPE_ITERATOR, ClickDirIterator))
#define CLICK_DIR_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLICK_DIR_TYPE_ITERATOR, ClickDirIteratorClass))
#define CLICK_DIR_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLICK_DIR_TYPE_ITERATOR))
#define CLICK_DIR_IS_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLICK_DIR_TYPE_ITERATOR))
#define CLICK_DIR_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLICK_DIR_TYPE_ITERATOR, ClickDirIteratorClass))

typedef struct _ClickDirIterator ClickDirIterator;
typedef struct _ClickDirIteratorClass ClickDirIteratorClass;

struct _ClickFrameworkPrivate {
	gchar* _name;
	GeeMap* fields;
};

static gint ClickFramework_private_offset;
static gpointer click_framework_parent_class = NULL;

static ClickFramework* click_framework_new (const gchar* name);
static ClickFramework* click_framework_construct (GType object_type,
                                           const gchar* name);
VALA_EXTERN GeeMap* click_parse_deb822_file (const gchar* path,
                                 GError** error);
VALA_EXTERN gboolean click_exists (const gchar* path);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN GType click_dir_iterator_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ClickDirIterator* click_dir_iterator (ClickDir* self);
VALA_EXTERN const gchar* click_dir_iterator_next_value (ClickDirIterator* self);
static void click_framework_finalize (GObject * obj);
static GType click_framework_get_type_once (void);
static void _vala_click_framework_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_click_framework_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

GQuark
click_framework_error_quark (void)
{
	return g_quark_from_static_string ("click-framework-error-quark");
}

static GType
click_framework_error_get_type_once (void)
{
	static const GEnumValue values[] = {{CLICK_FRAMEWORK_ERROR_NO_SUCH_FRAMEWORK, "CLICK_FRAMEWORK_ERROR_NO_SUCH_FRAMEWORK", "no-such-framework"}, {CLICK_FRAMEWORK_ERROR_MISSING_FIELD, "CLICK_FRAMEWORK_ERROR_MISSING_FIELD", "missing-field"}, {0, NULL, NULL}};
	GType click_framework_error_type_id;
	click_framework_error_type_id = g_enum_register_static ("ClickFrameworkError", values);
	return click_framework_error_type_id;
}

GType
click_framework_error_get_type (void)
{
	static volatile gsize click_framework_error_type_id__once = 0;
	if (g_once_init_enter (&click_framework_error_type_id__once)) {
		GType click_framework_error_type_id;
		click_framework_error_type_id = click_framework_error_get_type_once ();
		g_once_init_leave (&click_framework_error_type_id__once, click_framework_error_type_id);
	}
	return click_framework_error_type_id__once;
}

static inline gpointer
click_framework_get_instance_private (ClickFramework* self)
{
	return G_STRUCT_MEMBER_P (self, ClickFramework_private_offset);
}

static ClickFramework*
click_framework_construct (GType object_type,
                           const gchar* name)
{
	ClickFramework * self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (ClickFramework*) g_object_new (object_type, "name", name, NULL);
	return self;
}

static ClickFramework*
click_framework_new (const gchar* name)
{
	return click_framework_construct (CLICK_TYPE_FRAMEWORK, name);
}

/**
 * Framework.open:
 * @name: The name of the framework to open.
 *
 * Returns: (transfer full): A newly-allocated #Click.Framework.
 *
 * Since: 0.4.18
 */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

ClickFramework*
click_framework_open (const gchar* name,
                      GError** error)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GError* _inner_error0_ = NULL;
	ClickFramework* result;
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = click_get_frameworks_dir ();
	_tmp1_ = _tmp0_;
	_tmp2_ = string_to_string (name);
	_tmp3_ = g_strconcat (_tmp2_, ".framework", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_build_filename (_tmp1_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	_g_free0 (_tmp1_);
	path = _tmp6_;
	{
		ClickFramework* framework = NULL;
		ClickFramework* _tmp7_;
		GeeMap* _tmp8_ = NULL;
		const gchar* _tmp9_;
		GeeMap* _tmp10_;
		ClickFramework* _tmp11_;
		GeeMap* _tmp12_;
		_tmp7_ = click_framework_new (name);
		framework = _tmp7_;
		_tmp9_ = path;
		_tmp10_ = click_parse_deb822_file (_tmp9_, &_inner_error0_);
		_tmp8_ = _tmp10_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (framework);
			goto __catch0_g_error;
		}
		_tmp11_ = framework;
		_tmp12_ = _tmp8_;
		_tmp8_ = NULL;
		_g_object_unref0 (_tmp11_->priv->fields);
		_tmp11_->priv->fields = _tmp12_;
		result = framework;
		_g_object_unref0 (_tmp8_);
		_g_free0 (path);
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _tmp13_;
		g_clear_error (&_inner_error0_);
		_tmp13_ = g_error_new (CLICK_FRAMEWORK_ERROR, CLICK_FRAMEWORK_ERROR_NO_SUCH_FRAMEWORK, "No click framework '%s' installed", name);
		_inner_error0_ = _tmp13_;
		goto __finally0;
	}
	__finally0:
	if (_inner_error0_->domain == CLICK_FRAMEWORK_ERROR) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (path);
		return NULL;
	} else {
		_g_free0 (path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

/**
 * has_framework:
 * @name: A framework name.
 *
 * Returns: True if a framework by this name exists, otherwise false.
 *
 * Since: 0.4.18
 */
gboolean
click_framework_has_framework (const gchar* name)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean result;
	g_return_val_if_fail (name != NULL, FALSE);
	_tmp0_ = click_get_frameworks_dir ();
	_tmp1_ = _tmp0_;
	_tmp2_ = string_to_string (name);
	_tmp3_ = g_strconcat (_tmp2_, ".framework", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_build_filename (_tmp1_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	_g_free0 (_tmp1_);
	path = _tmp6_;
	result = click_exists (path);
	_g_free0 (path);
	return result;
}

/**
 * get_frameworks:
 *
 * Returns: (element-type ClickFramework) (transfer full): A #List
 * of all #Click.Framework instances installed on the system.
 *
 * Since: 0.4.18
 */
static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

GList*
click_framework_get_frameworks (void)
{
	GList* ret = NULL;
	ClickDir* dir = NULL;
	GError* _inner_error0_ = NULL;
	GList* result;
	ret = NULL;
	{
		ClickDir* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		ClickDir* _tmp3_;
		ClickDir* _tmp4_;
		ClickDir* _tmp5_;
		_tmp1_ = click_get_frameworks_dir ();
		_tmp2_ = _tmp1_;
		_tmp3_ = click_dir_open (_tmp2_, (guint) 0, &_inner_error0_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		_tmp0_ = _tmp4_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_FILE_ERROR) {
				goto __catch0_g_file_error;
			}
			_g_object_unref0 (dir);
			(ret == NULL) ? NULL : (ret = (_g_list_free__g_object_unref0_ (ret), NULL));
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp5_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (dir);
		dir = _tmp5_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		g_clear_error (&_inner_error0_);
		result = ret;
		_g_object_unref0 (dir);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (dir);
		(ret == NULL) ? NULL : (ret = (_g_list_free__g_object_unref0_ (ret), NULL));
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	{
		ClickDirIterator* _entry_it = NULL;
		ClickDir* _tmp6_;
		ClickDirIterator* _tmp7_;
		const gchar* entry = NULL;
		_tmp6_ = dir;
		_tmp7_ = click_dir_iterator (_tmp6_);
		_entry_it = _tmp7_;
		while (TRUE) {
			ClickDirIterator* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			_tmp8_ = _entry_it;
			_tmp9_ = click_dir_iterator_next_value (_tmp8_);
			entry = _tmp9_;
			_tmp10_ = entry;
			if (!(_tmp10_ != NULL)) {
				break;
			}
			_tmp11_ = entry;
			if (!g_str_has_suffix (_tmp11_, ".framework")) {
				continue;
			}
			{
				ClickFramework* _tmp12_ = NULL;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				ClickFramework* _tmp16_;
				ClickFramework* _tmp17_;
				ClickFramework* _tmp18_;
				_tmp13_ = entry;
				_tmp14_ = string_slice (_tmp13_, (glong) 0, (glong) -10);
				_tmp15_ = _tmp14_;
				_tmp16_ = click_framework_open (_tmp15_, &_inner_error0_);
				_tmp17_ = _tmp16_;
				_g_free0 (_tmp15_);
				_tmp12_ = _tmp17_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch1_g_error;
				}
				_tmp18_ = _tmp12_;
				_tmp12_ = NULL;
				ret = g_list_prepend (ret, _tmp18_);
				_g_object_unref0 (_tmp12_);
			}
			goto __finally1;
			__catch1_g_error:
			{
				g_clear_error (&_inner_error0_);
				continue;
			}
			__finally1:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (_entry_it);
				_g_object_unref0 (dir);
				(ret == NULL) ? NULL : (ret = (_g_list_free__g_object_unref0_ (ret), NULL));
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_g_object_unref0 (_entry_it);
	}
	ret = g_list_reverse (ret);
	result = ret;
	_g_object_unref0 (dir);
	return result;
}

/**
 * get_fields:
 *
 * Returns: A list of field names defined by this framework.
 *
 * Since: 0.4.18
 */
GList*
click_framework_get_fields (ClickFramework* self)
{
	GList* ret = NULL;
	GList* result;
	g_return_val_if_fail (self != NULL, NULL);
	ret = NULL;
	{
		GeeIterator* _key_it = NULL;
		GeeMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->fields;
		_tmp1_ = gee_map_get_keys (_tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_key_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			gchar* key = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			_tmp6_ = _key_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _key_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			key = (gchar*) _tmp8_;
			_tmp9_ = key;
			_tmp10_ = g_strdup (_tmp9_);
			ret = g_list_prepend (ret, _tmp10_);
			_g_free0 (key);
		}
		_g_object_unref0 (_key_it);
	}
	ret = g_list_reverse (ret);
	result = ret;
	return result;
}

gchar*
click_framework_get_field (ClickFramework* self,
                           const gchar* key,
                           GError** error)
{
	gchar* value = NULL;
	GeeMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gpointer _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	_tmp0_ = self->priv->fields;
	_tmp1_ = g_utf8_strdown (key, (gssize) -1);
	_tmp2_ = _tmp1_;
	_tmp3_ = gee_map_get (_tmp0_, _tmp2_);
	_tmp4_ = (gchar*) _tmp3_;
	_g_free0 (_tmp2_);
	value = _tmp4_;
	_tmp5_ = value;
	if (_tmp5_ == NULL) {
		const gchar* _tmp6_;
		GError* _tmp7_;
		_tmp6_ = self->priv->_name;
		_tmp7_ = g_error_new (CLICK_FRAMEWORK_ERROR, CLICK_FRAMEWORK_ERROR_MISSING_FIELD, "Framework '%s' has no field named '%s'", _tmp6_, key);
		_inner_error0_ = _tmp7_;
		if (_inner_error0_->domain == CLICK_FRAMEWORK_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (value);
			return NULL;
		} else {
			_g_free0 (value);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = value;
	return result;
}

gchar*
click_framework_get_base_name (ClickFramework* self)
{
	GeeMap* _tmp0_;
	gpointer _tmp1_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->fields;
	_tmp1_ = gee_map_get (_tmp0_, "base-name");
	result = (gchar*) _tmp1_;
	return result;
}

gchar*
click_framework_get_base_version (ClickFramework* self)
{
	GeeMap* _tmp0_;
	gpointer _tmp1_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->fields;
	_tmp1_ = gee_map_get (_tmp0_, "base-version");
	result = (gchar*) _tmp1_;
	return result;
}

const gchar*
click_framework_get_name (ClickFramework* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

static void
click_framework_set_name (ClickFramework* self,
                          const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = click_framework_get_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, click_framework_properties[CLICK_FRAMEWORK_NAME_PROPERTY]);
	}
}

static void
click_framework_class_init (ClickFrameworkClass * klass,
                            gpointer klass_data)
{
	click_framework_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ClickFramework_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_click_framework_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_click_framework_set_property;
	G_OBJECT_CLASS (klass)->finalize = click_framework_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLICK_FRAMEWORK_NAME_PROPERTY, click_framework_properties[CLICK_FRAMEWORK_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
click_framework_instance_init (ClickFramework * self,
                               gpointer klass)
{
	self->priv = click_framework_get_instance_private (self);
}

static void
click_framework_finalize (GObject * obj)
{
	ClickFramework * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLICK_TYPE_FRAMEWORK, ClickFramework);
	_g_free0 (self->priv->_name);
	_g_object_unref0 (self->priv->fields);
	G_OBJECT_CLASS (click_framework_parent_class)->finalize (obj);
}

static GType
click_framework_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClickFrameworkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) click_framework_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClickFramework), 0, (GInstanceInitFunc) click_framework_instance_init, NULL };
	GType click_framework_type_id;
	click_framework_type_id = g_type_register_static (G_TYPE_OBJECT, "ClickFramework", &g_define_type_info, 0);
	ClickFramework_private_offset = g_type_add_instance_private (click_framework_type_id, sizeof (ClickFrameworkPrivate));
	return click_framework_type_id;
}

GType
click_framework_get_type (void)
{
	static volatile gsize click_framework_type_id__once = 0;
	if (g_once_init_enter (&click_framework_type_id__once)) {
		GType click_framework_type_id;
		click_framework_type_id = click_framework_get_type_once ();
		g_once_init_leave (&click_framework_type_id__once, click_framework_type_id);
	}
	return click_framework_type_id__once;
}

static void
_vala_click_framework_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	ClickFramework * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CLICK_TYPE_FRAMEWORK, ClickFramework);
	switch (property_id) {
		case CLICK_FRAMEWORK_NAME_PROPERTY:
		g_value_set_string (value, click_framework_get_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_click_framework_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	ClickFramework * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CLICK_TYPE_FRAMEWORK, ClickFramework);
	switch (property_id) {
		case CLICK_FRAMEWORK_NAME_PROPERTY:
		click_framework_set_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

