/* osextras.c generated by valac 0.56.8, the Vala compiler
 * generated from osextras.vala, do not modify */

/* Copyright (C) 2013, 2014 Canonical Ltd.
 * Author: Colin Watson <cjwatson@ubuntu.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Extra OS-level utility functions.  */

#include "click.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gstdio.h>
#include <errno.h>
#include <gio/gio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <glib-object.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	CLICK_DIR_0_PROPERTY,
	CLICK_DIR_NUM_PROPERTIES
};
static GParamSpec* click_dir_properties[CLICK_DIR_NUM_PROPERTIES];
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))

#define CLICK_DIR_TYPE_ITERATOR (click_dir_iterator_get_type ())
#define CLICK_DIR_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLICK_DIR_TYPE_ITERATOR, ClickDirIterator))
#define CLICK_DIR_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLICK_DIR_TYPE_ITERATOR, ClickDirIteratorClass))
#define CLICK_DIR_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLICK_DIR_TYPE_ITERATOR))
#define CLICK_DIR_IS_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLICK_DIR_TYPE_ITERATOR))
#define CLICK_DIR_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLICK_DIR_TYPE_ITERATOR, ClickDirIteratorClass))

typedef struct _ClickDirIterator ClickDirIterator;
typedef struct _ClickDirIteratorClass ClickDirIteratorClass;
typedef struct _ClickDirIteratorPrivate ClickDirIteratorPrivate;
enum  {
	CLICK_DIR_ITERATOR_0_PROPERTY,
	CLICK_DIR_ITERATOR_NUM_PROPERTIES
};
static GParamSpec* click_dir_iterator_properties[CLICK_DIR_ITERATOR_NUM_PROPERTIES];

struct _ClickDirPrivate {
	GSList* entries;
	GSList* cur;
};

struct _ClickDirIterator {
	GObject parent_instance;
	ClickDirIteratorPrivate * priv;
};

struct _ClickDirIteratorClass {
	GObjectClass parent_class;
};

struct _ClickDirIteratorPrivate {
	ClickDir* dir;
};

static gint ClickDir_private_offset;
static gpointer click_dir_parent_class = NULL;
static gint ClickDirIterator_private_offset;
static gpointer click_dir_iterator_parent_class = NULL;

VALA_EXTERN gboolean click_is_dir (const gchar* path);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static ClickDir* click_dir_new (void);
static ClickDir* click_dir_construct (GType object_type);
VALA_EXTERN GType click_dir_iterator_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ClickDirIterator* click_dir_iterator (ClickDir* self);
VALA_EXTERN ClickDirIterator* click_dir_iterator_new (ClickDir* dir);
VALA_EXTERN ClickDirIterator* click_dir_iterator_construct (GType object_type,
                                                ClickDir* dir);
VALA_EXTERN const gchar* click_dir_iterator_next_value (ClickDirIterator* self);
static void click_dir_iterator_finalize (GObject * obj);
static GType click_dir_iterator_get_type_once (void);
static void click_dir_finalize (GObject * obj);
static GType click_dir_get_type_once (void);
VALA_EXTERN gboolean click_exists (const gchar* path);
VALA_EXTERN gboolean click_is_symlink (const gchar* path);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

/**
 * find_on_path:
 * @command: A command name.
 *
 * Returns: True if the command is on the executable search path, otherwise
 * false.
 */
gboolean
click_find_on_path (const gchar* command)
{
	const gchar* path = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar** elements = NULL;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint elements_length1;
	gint _elements_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gboolean result;
	g_return_val_if_fail (command != NULL, FALSE);
	_tmp0_ = g_getenv ("PATH");
	path = _tmp0_;
	_tmp1_ = path;
	if (_tmp1_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp2_ = path;
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, ":", 0);
	elements = _tmp4_;
	elements_length1 = _vala_array_length (_tmp3_);
	_elements_size_ = elements_length1;
	_tmp5_ = elements;
	_tmp5__length1 = elements_length1;
	{
		gchar** element_collection = NULL;
		gint element_collection_length1 = 0;
		gint _element_collection_size_ = 0;
		gint element_it = 0;
		element_collection = _tmp5_;
		element_collection_length1 = _tmp5__length1;
		for (element_it = 0; element_it < element_collection_length1; element_it = element_it + 1) {
			gchar* _tmp6_;
			gchar* element = NULL;
			_tmp6_ = g_strdup (element_collection[element_it]);
			element = _tmp6_;
			{
				const gchar* _tmp7_;
				gchar* filename = NULL;
				const gchar* _tmp8_;
				gchar* _tmp9_;
				gboolean _tmp10_ = FALSE;
				const gchar* _tmp11_;
				_tmp7_ = element;
				if (g_strcmp0 (_tmp7_, "") == 0) {
					_g_free0 (element);
					continue;
				}
				_tmp8_ = element;
				_tmp9_ = g_build_filename (_tmp8_, command, NULL);
				filename = _tmp9_;
				_tmp11_ = filename;
				if (g_file_test (_tmp11_, G_FILE_TEST_IS_REGULAR)) {
					const gchar* _tmp12_;
					_tmp12_ = filename;
					_tmp10_ = g_file_test (_tmp12_, G_FILE_TEST_IS_EXECUTABLE);
				} else {
					_tmp10_ = FALSE;
				}
				if (_tmp10_) {
					result = TRUE;
					_g_free0 (filename);
					_g_free0 (element);
					elements = (_vala_array_free (elements, elements_length1, (GDestroyNotify) g_free), NULL);
					return result;
				}
				_g_free0 (filename);
				_g_free0 (element);
			}
		}
	}
	result = FALSE;
	elements = (_vala_array_free (elements, elements_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

/**
 * ensuredir:
 * @directory: A path.
 *
 * If @directory does not already exist, create it and its parents as
 * needed.
 */
static gpointer
_g_error_copy0 (gpointer self)
{
	return self ? g_error_copy (self) : NULL;
}

void
click_ensuredir (const gchar* directory,
                 GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (directory != NULL);
	if (click_is_dir (directory)) {
		return;
	}
	if (g_mkdir_with_parents (directory, 0777) < 0) {
		gint code = 0;
		GQuark quark = 0U;
		GError* err = NULL;
		const gchar* _tmp0_;
		GError* _tmp1_;
		GError* _tmp2_;
		GError* _tmp3_;
		code = g_file_error_from_errno (errno);
		quark = g_quark_from_string ("g-file-error-quark");
		_tmp0_ = g_strerror (errno);
		_tmp1_ = g_error_new (quark, code, "ensuredir %s failed: %s", directory, _tmp0_);
		err = _tmp1_;
		_tmp2_ = err;
		_tmp3_ = _g_error_copy0 ((GError*) _tmp2_);
		_inner_error0_ = _tmp3_;
		if (_inner_error0_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_error_free0 (err);
			return;
		} else {
			_g_error_free0 (err);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_g_error_free0 (err);
	}
}

/**
 * rmtree:
 * @file: A #File to delete
 *
 * Errors when the directory can not be removed
 */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

gboolean
click_rmtree (GFile* file,
              GCancellable* cancellable,
              GError** error)
{
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp0_;
	gboolean _tmp19_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (file != NULL, FALSE);
	_tmp0_ = g_file_enumerate_children (file, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
	enumerator = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp1_ = FALSE;
		g_propagate_error (error, _inner_error0_);
		return _tmp1_;
	}
	while (TRUE) {
		GFileEnumerator* _tmp2_;
		GFile* child = NULL;
		gboolean _tmp3_ = FALSE;
		GFileEnumerator* _tmp4_;
		GFile* _tmp5_ = NULL;
		gboolean _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp9_;
		_tmp2_ = enumerator;
		if (!(_tmp2_ != NULL)) {
			break;
		}
		_tmp4_ = enumerator;
		_tmp6_ = g_file_enumerator_iterate (_tmp4_, NULL, &_tmp5_, cancellable, &_inner_error0_);
		_g_object_unref0 (child);
		_tmp7_ = _g_object_ref0 (_tmp5_);
		child = _tmp7_;
		_tmp3_ = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp8_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (child);
			_g_object_unref0 (enumerator);
			return _tmp8_;
		}
		if (!_tmp3_) {
			result = FALSE;
			_g_object_unref0 (child);
			_g_object_unref0 (enumerator);
			return result;
		}
		_tmp9_ = child;
		if (_tmp9_ == NULL) {
			_g_object_unref0 (child);
			break;
		}
		{
			GFile* _tmp10_;
			_tmp10_ = child;
			switch (g_file_query_file_type (_tmp10_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL)) {
				case G_FILE_TYPE_DIRECTORY:
				{
					GFile* _tmp11_;
					_tmp11_ = child;
					click_rmtree (_tmp11_, cancellable, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch0_g_error;
					}
					break;
				}
				default:
				case G_FILE_TYPE_SYMBOLIC_LINK:
				{
					GFile* _tmp12_;
					_tmp12_ = child;
					g_file_delete (_tmp12_, cancellable, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch0_g_error;
					}
					break;
				}
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GFile* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			GError* _tmp16_;
			const gchar* _tmp17_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp13_ = child;
			_tmp14_ = g_file_get_path (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = e;
			_tmp17_ = _tmp16_->message;
			g_warning ("osextras.vala:101: Error removing '%s': %s", _tmp15_, _tmp17_);
			_g_free0 (_tmp15_);
			_g_error_free0 (e);
			_g_object_unref0 (child);
			continue;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp18_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (child);
			_g_object_unref0 (enumerator);
			return _tmp18_;
		}
		_g_object_unref0 (child);
	}
	_tmp19_ = g_file_delete (file, cancellable, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp20_ = FALSE;
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (enumerator);
		return _tmp20_;
	}
	result = _tmp19_;
	_g_object_unref0 (enumerator);
	return result;
}

/**
 * unlink_force:
 * @path: A path to unlink.
 *
 * Unlink path, without worrying about whether it exists.  Errors other than
 * %ENOENT will set the provided error location.
 */
void
click_unlink_force (const gchar* path,
                    GError** error)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (path != NULL);
	if (g_unlink (path) < 0) {
		_tmp0_ = errno != ENOENT;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint code = 0;
		GQuark quark = 0U;
		GError* err = NULL;
		const gchar* _tmp1_;
		GError* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
		code = g_file_error_from_errno (errno);
		quark = g_quark_from_string ("g-file-error-quark");
		_tmp1_ = g_strerror (errno);
		_tmp2_ = g_error_new (quark, code, "unlink %s failed: %s", path, _tmp1_);
		err = _tmp2_;
		_tmp3_ = err;
		_tmp4_ = _g_error_copy0 ((GError*) _tmp3_);
		_inner_error0_ = _tmp4_;
		if (_inner_error0_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_error_free0 (err);
			return;
		} else {
			_g_error_free0 (err);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_g_error_free0 (err);
	}
}

/**
 * symlink_force:
 * @target: The intended target of the symbolic link.
 * @link_name: A path where the symbolic link should be created.
 *
 * Create a symlink link_name -> target, even if link_name exists.
 */
void
click_symlink_force (const gchar* target,
                     const gchar* link_name,
                     GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (target != NULL);
	g_return_if_fail (link_name != NULL);
	click_unlink_force (link_name, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	if (symlink (target, link_name) < 0) {
		gint code = 0;
		GQuark quark = 0U;
		GError* err = NULL;
		const gchar* _tmp0_;
		GError* _tmp1_;
		GError* _tmp2_;
		GError* _tmp3_;
		code = g_file_error_from_errno (errno);
		quark = g_quark_from_string ("g-file-error-quark");
		_tmp0_ = g_strerror (errno);
		_tmp1_ = g_error_new (quark, code, "symlink %s -> %s failed: %s", link_name, target, _tmp0_);
		err = _tmp1_;
		_tmp2_ = err;
		_tmp3_ = _g_error_copy0 ((GError*) _tmp2_);
		_inner_error0_ = _tmp3_;
		if (_inner_error0_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_error_free0 (err);
			return;
		} else {
			_g_error_free0 (err);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_g_error_free0 (err);
	}
}

/**
 * click_get_umask:
 *
 * Returns: The current umask.
 */
gint
click_get_umask (void)
{
	mode_t mask = {0};
	gint result;
	mask = umask ((mode_t) 0);
	umask (mask);
	result = (gint) mask;
	return result;
}

static inline gpointer
click_dir_get_instance_private (ClickDir* self)
{
	return G_STRUCT_MEMBER_P (self, ClickDir_private_offset);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
}

static ClickDir*
click_dir_construct (GType object_type)
{
	ClickDir * self = NULL;
	self = (ClickDir*) g_object_new (object_type, NULL);
	return self;
}

static ClickDir*
click_dir_new (void)
{
	return click_dir_construct (CLICK_TYPE_DIR);
}

/**
 * open:
 * @path: The path to the directory to open.
 * @flags: For future use; currently must be set to 0.
 *
 * Like GLib.Dir.open(), but ignores %ENOENT.
 */
ClickDir*
click_dir_open (const gchar* path,
                guint _flags,
                GError** error)
{
	ClickDir* dir = NULL;
	ClickDir* _tmp0_;
	ClickDir* _tmp1_;
	GDir* real_dir = NULL;
	ClickDir* _tmp17_;
	ClickDir* _tmp18_;
	GSList* _tmp19_;
	GError* _inner_error0_ = NULL;
	ClickDir* result;
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = click_dir_new ();
	dir = _tmp0_;
	_tmp1_ = dir;
	(_tmp1_->priv->entries == NULL) ? NULL : (_tmp1_->priv->entries = (_g_slist_free__g_free0_ (_tmp1_->priv->entries), NULL));
	_tmp1_->priv->entries = NULL;
	{
		GDir* _tmp2_ = NULL;
		GDir* _tmp3_;
		GDir* _tmp4_;
		gchar* name = NULL;
		ClickDir* _tmp12_;
		GCompareFunc _tmp13_;
		_tmp3_ = g_dir_open (path, _flags, &_inner_error0_);
		_tmp2_ = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_FILE_ERROR) {
				goto __catch0_g_file_error;
			}
			_g_dir_close0 (real_dir);
			_g_object_unref0 (dir);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp4_ = _tmp2_;
		_tmp2_ = NULL;
		_g_dir_close0 (real_dir);
		real_dir = _tmp4_;
		while (TRUE) {
			GDir* _tmp5_;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			const gchar* _tmp8_;
			ClickDir* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			_tmp5_ = real_dir;
			_tmp6_ = g_dir_read_name (_tmp5_);
			_tmp7_ = g_strdup (_tmp6_);
			_g_free0 (name);
			name = _tmp7_;
			_tmp8_ = name;
			if (!(_tmp8_ != NULL)) {
				break;
			}
			_tmp9_ = dir;
			_tmp10_ = name;
			_tmp11_ = g_strdup (_tmp10_);
			_tmp9_->priv->entries = g_slist_prepend (_tmp9_->priv->entries, _tmp11_);
		}
		_tmp12_ = dir;
		_tmp13_ = ((GCompareFunc) g_strcmp0);
		_tmp12_->priv->entries = g_slist_sort (_tmp12_->priv->entries, _tmp13_);
		_g_free0 (name);
		_g_dir_close0 (_tmp2_);
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp14_ = e;
		if (!g_error_matches (_tmp14_, G_FILE_ERROR, G_FILE_ERROR_NOENT)) {
			GError* _tmp15_;
			GError* _tmp16_;
			_tmp15_ = e;
			_tmp16_ = _g_error_copy0 (_tmp15_);
			_inner_error0_ = _tmp16_;
			_g_error_free0 (e);
			goto __finally0;
		}
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_dir_close0 (real_dir);
			_g_object_unref0 (dir);
			return NULL;
		} else {
			_g_dir_close0 (real_dir);
			_g_object_unref0 (dir);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp17_ = dir;
	_tmp18_ = dir;
	_tmp19_ = _tmp18_->priv->entries;
	_tmp17_->priv->cur = _tmp19_;
	result = dir;
	_g_dir_close0 (real_dir);
	return result;
}

/**
 * read_name:
 *
 * Like GLib.Dir.read_name(), but returns entries in sorted order.
 */
const gchar*
click_dir_read_name (ClickDir* self)
{
	GSList* _tmp0_;
	const gchar* name = NULL;
	GSList* _tmp1_;
	gconstpointer _tmp2_;
	GSList* _tmp3_;
	GSList* _tmp4_;
	const gchar* _tmp5_;
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->cur;
	if (_tmp0_ == NULL) {
		result = NULL;
		return result;
	}
	_tmp1_ = self->priv->cur;
	_tmp2_ = _tmp1_->data;
	name = (const gchar*) _tmp2_;
	_tmp3_ = self->priv->cur;
	_tmp4_ = _tmp3_->next;
	self->priv->cur = _tmp4_;
	_tmp5_ = name;
	result = _tmp5_;
	return result;
}

ClickDirIterator*
click_dir_iterator (ClickDir* self)
{
	ClickDirIterator* _tmp0_;
	ClickDirIterator* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = click_dir_iterator_new (self);
	result = _tmp0_;
	return result;
}

static inline gpointer
click_dir_iterator_get_instance_private (ClickDirIterator* self)
{
	return G_STRUCT_MEMBER_P (self, ClickDirIterator_private_offset);
}

ClickDirIterator*
click_dir_iterator_construct (GType object_type,
                              ClickDir* dir)
{
	ClickDirIterator * self = NULL;
	ClickDir* _tmp0_;
	g_return_val_if_fail (dir != NULL, NULL);
	self = (ClickDirIterator*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (dir);
	_g_object_unref0 (self->priv->dir);
	self->priv->dir = _tmp0_;
	return self;
}

ClickDirIterator*
click_dir_iterator_new (ClickDir* dir)
{
	return click_dir_iterator_construct (CLICK_DIR_TYPE_ITERATOR, dir);
}

const gchar*
click_dir_iterator_next_value (ClickDirIterator* self)
{
	ClickDir* _tmp0_;
	const gchar* _tmp1_;
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->dir;
	_tmp1_ = click_dir_read_name (_tmp0_);
	result = _tmp1_;
	return result;
}

static void
click_dir_iterator_class_init (ClickDirIteratorClass * klass,
                               gpointer klass_data)
{
	click_dir_iterator_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ClickDirIterator_private_offset);
	G_OBJECT_CLASS (klass)->finalize = click_dir_iterator_finalize;
}

static void
click_dir_iterator_instance_init (ClickDirIterator * self,
                                  gpointer klass)
{
	self->priv = click_dir_iterator_get_instance_private (self);
}

static void
click_dir_iterator_finalize (GObject * obj)
{
	ClickDirIterator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLICK_DIR_TYPE_ITERATOR, ClickDirIterator);
	_g_object_unref0 (self->priv->dir);
	G_OBJECT_CLASS (click_dir_iterator_parent_class)->finalize (obj);
}

static GType
click_dir_iterator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClickDirIteratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) click_dir_iterator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClickDirIterator), 0, (GInstanceInitFunc) click_dir_iterator_instance_init, NULL };
	GType click_dir_iterator_type_id;
	click_dir_iterator_type_id = g_type_register_static (G_TYPE_OBJECT, "ClickDirIterator", &g_define_type_info, 0);
	ClickDirIterator_private_offset = g_type_add_instance_private (click_dir_iterator_type_id, sizeof (ClickDirIteratorPrivate));
	return click_dir_iterator_type_id;
}

GType
click_dir_iterator_get_type (void)
{
	static volatile gsize click_dir_iterator_type_id__once = 0;
	if (g_once_init_enter (&click_dir_iterator_type_id__once)) {
		GType click_dir_iterator_type_id;
		click_dir_iterator_type_id = click_dir_iterator_get_type_once ();
		g_once_init_leave (&click_dir_iterator_type_id__once, click_dir_iterator_type_id);
	}
	return click_dir_iterator_type_id__once;
}

static void
click_dir_class_init (ClickDirClass * klass,
                      gpointer klass_data)
{
	click_dir_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ClickDir_private_offset);
	G_OBJECT_CLASS (klass)->finalize = click_dir_finalize;
}

static void
click_dir_instance_init (ClickDir * self,
                         gpointer klass)
{
	self->priv = click_dir_get_instance_private (self);
}

static void
click_dir_finalize (GObject * obj)
{
	ClickDir * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLICK_TYPE_DIR, ClickDir);
	(self->priv->entries == NULL) ? NULL : (self->priv->entries = (_g_slist_free__g_free0_ (self->priv->entries), NULL));
	G_OBJECT_CLASS (click_dir_parent_class)->finalize (obj);
}

static GType
click_dir_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClickDirClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) click_dir_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClickDir), 0, (GInstanceInitFunc) click_dir_instance_init, NULL };
	GType click_dir_type_id;
	click_dir_type_id = g_type_register_static (G_TYPE_OBJECT, "ClickDir", &g_define_type_info, 0);
	ClickDir_private_offset = g_type_add_instance_private (click_dir_type_id, sizeof (ClickDirPrivate));
	return click_dir_type_id;
}

GType
click_dir_get_type (void)
{
	static volatile gsize click_dir_type_id__once = 0;
	if (g_once_init_enter (&click_dir_type_id__once)) {
		GType click_dir_type_id;
		click_dir_type_id = click_dir_get_type_once ();
		g_once_init_leave (&click_dir_type_id__once, click_dir_type_id);
	}
	return click_dir_type_id__once;
}

gboolean
click_exists (const gchar* path)
{
	gboolean result;
	g_return_val_if_fail (path != NULL, FALSE);
	result = g_file_test (path, G_FILE_TEST_EXISTS);
	return result;
}

gboolean
click_is_symlink (const gchar* path)
{
	gboolean result;
	g_return_val_if_fail (path != NULL, FALSE);
	result = g_file_test (path, G_FILE_TEST_IS_SYMLINK);
	return result;
}

gboolean
click_is_dir (const gchar* path)
{
	gboolean result;
	g_return_val_if_fail (path != NULL, FALSE);
	result = g_file_test (path, G_FILE_TEST_IS_DIR);
	return result;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

