/* query.c generated by valac 0.56.8, the Vala compiler
 * generated from query.vala, do not modify */

/* Copyright (C) 2013, 2014 Canonical Ltd.
 * Author: Colin Watson <cjwatson@ubuntu.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Query information about installed Click packages.  */

#include "click.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <errno.h>

#define _g_free0(var) (var = (g_free (var), NULL))

VALA_EXTERN gboolean click_is_dir (const gchar* path);

GQuark
click_query_error_quark (void)
{
	return g_quark_from_static_string ("click-query-error-quark");
}

static GType
click_query_error_get_type_once (void)
{
	static const GEnumValue values[] = {{CLICK_QUERY_ERROR_PATH, "CLICK_QUERY_ERROR_PATH", "path"}, {CLICK_QUERY_ERROR_NO_PACKAGE_DIR, "CLICK_QUERY_ERROR_NO_PACKAGE_DIR", "no-package-dir"}, {0, NULL, NULL}};
	GType click_query_error_type_id;
	click_query_error_type_id = g_enum_register_static ("ClickQueryError", values);
	return click_query_error_type_id;
}

GType
click_query_error_get_type (void)
{
	static volatile gsize click_query_error_type_id__once = 0;
	if (g_once_init_enter (&click_query_error_type_id__once)) {
		GType click_query_error_type_id;
		click_query_error_type_id = click_query_error_get_type_once ();
		g_once_init_leave (&click_query_error_type_id__once, click_query_error_type_id);
	}
	return click_query_error_type_id__once;
}

gchar*
click_find_package_directory (const gchar* path,
                              GError** error)
{
	gchar* dir = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GError* _tmp16_;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = realpath (path, NULL);
	dir = _tmp0_;
	_tmp1_ = dir;
	if (_tmp1_ == NULL) {
		const gchar* _tmp2_;
		GError* _tmp3_;
		_tmp2_ = g_strerror (errno);
		_tmp3_ = g_error_new (CLICK_QUERY_ERROR, CLICK_QUERY_ERROR_PATH, "Failed to canonicalize %s: %s", path, _tmp2_);
		_inner_error0_ = _tmp3_;
		if (_inner_error0_->domain == CLICK_QUERY_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (dir);
			return NULL;
		} else {
			_g_free0 (dir);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	{
		gboolean _tmp4_ = FALSE;
		_tmp4_ = TRUE;
		while (TRUE) {
			gchar* info_dir = NULL;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			gchar* new_dir = NULL;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			if (!_tmp4_) {
				const gchar* _tmp5_;
				_tmp5_ = dir;
				if (!(_tmp5_ != NULL)) {
					break;
				}
			}
			_tmp4_ = FALSE;
			_tmp6_ = dir;
			_tmp7_ = g_build_filename (_tmp6_, ".click", "info", NULL);
			info_dir = _tmp7_;
			_tmp8_ = info_dir;
			if (click_is_dir (_tmp8_)) {
				result = dir;
				_g_free0 (info_dir);
				return result;
			}
			_tmp9_ = dir;
			if (g_strcmp0 (_tmp9_, ".") == 0) {
				_g_free0 (info_dir);
				break;
			}
			_tmp10_ = dir;
			_tmp11_ = g_path_get_dirname (_tmp10_);
			new_dir = _tmp11_;
			_tmp12_ = new_dir;
			_tmp13_ = dir;
			if (g_strcmp0 (_tmp12_, _tmp13_) == 0) {
				_g_free0 (new_dir);
				_g_free0 (info_dir);
				break;
			}
			_tmp14_ = new_dir;
			_tmp15_ = g_strdup (_tmp14_);
			_g_free0 (dir);
			dir = _tmp15_;
			_g_free0 (new_dir);
			_g_free0 (info_dir);
		}
	}
	_tmp16_ = g_error_new (CLICK_QUERY_ERROR, CLICK_QUERY_ERROR_NO_PACKAGE_DIR, "No package directory found for %s", path);
	_inner_error0_ = _tmp16_;
	if (_inner_error0_->domain == CLICK_QUERY_ERROR) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (dir);
		return NULL;
	} else {
		_g_free0 (dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

