/* user.c generated by valac 0.56.8, the Vala compiler
 * generated from user.vala, do not modify */

/* Copyright (C) 2013, 2014 Canonical Ltd.
 * Author: Colin Watson <cjwatson@ubuntu.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Registry of user-installed Click packages.
 * 
 * Click packages are installed into per-package/version directories, so it
 * is quite feasible for more than one version of a given package to be
 * installed at once, allowing per-user installations; for instance, one
 * user of a tablet may be uncomfortable with granting some new permission
 * to an app, but another may be just fine with it.  To make this useful, we
 * also need a registry of which users have which versions of each package
 * installed.
 * 
 * We might have chosen to use a proper database.  However, a major goal of
 * Click packages is extreme resilience; we must never get into a situation
 * where some previous error in package installation or removal makes it
 * hard for the user to install or remove other packages.  Furthermore, the
 * simpler application execution can be the better.  So, instead, we use
 * just about the simplest "database" format imaginable: a directory of
 * symlinks per user.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "click.h"
#include <glib/gstdio.h>
#include <errno.h>
#include <sys/types.h>
#include <unistd.h>
#include <pwd.h>
#include <gee.h>
#include <sys/stat.h>
#include <json-glib/json-glib.h>

#define CLICK_ALL_USERS "@all"
#define CLICK_GC_IN_USE_USER "@gcinuse"
#define CLICK_HIDDEN_VERSION "@hidden"

#define CLICK_TYPE_LOGIND_USER (click_logind_user_get_type ())
typedef struct _ClickLogindUser ClickLogindUser;
#define _g_free0(var) (var = (g_free (var), NULL))

#define CLICK_TYPE_LOGIND_MANAGER (click_logind_manager_get_type ())
#define CLICK_LOGIND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLICK_TYPE_LOGIND_MANAGER, ClickLogindManager))
#define CLICK_IS_LOGIND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLICK_TYPE_LOGIND_MANAGER))
#define CLICK_LOGIND_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), CLICK_TYPE_LOGIND_MANAGER, ClickLogindManagerIface))

typedef struct _ClickLogindManager ClickLogindManager;
typedef struct _ClickLogindManagerIface ClickLogindManagerIface;

#define CLICK_TYPE_LOGIND_MANAGER_PROXY (click_logind_manager_proxy_get_type ())
typedef GDBusProxy ClickLogindManagerProxy;
typedef GDBusProxyClass ClickLogindManagerProxyClass;

#define CLICK_TYPE_AS_USER (click_as_user_get_type ())
#define CLICK_AS_USER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLICK_TYPE_AS_USER, ClickASUser))
#define CLICK_IS_AS_USER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLICK_TYPE_AS_USER))
#define CLICK_AS_USER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), CLICK_TYPE_AS_USER, ClickASUserIface))

typedef struct _ClickASUser ClickASUser;
typedef struct _ClickASUserIface ClickASUserIface;

#define CLICK_TYPE_AS_USER_PROXY (click_as_user_proxy_get_type ())
typedef GDBusProxy ClickASUserProxy;
typedef GDBusProxyClass ClickASUserProxyClass;

#define CLICK_TYPE_CACHED_PASSWD (click_cached_passwd_get_type ())
#define CLICK_CACHED_PASSWD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLICK_TYPE_CACHED_PASSWD, ClickCachedPasswd))
#define CLICK_CACHED_PASSWD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLICK_TYPE_CACHED_PASSWD, ClickCachedPasswdClass))
#define CLICK_IS_CACHED_PASSWD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLICK_TYPE_CACHED_PASSWD))
#define CLICK_IS_CACHED_PASSWD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLICK_TYPE_CACHED_PASSWD))
#define CLICK_CACHED_PASSWD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLICK_TYPE_CACHED_PASSWD, ClickCachedPasswdClass))

typedef struct _ClickCachedPasswd ClickCachedPasswd;
typedef struct _ClickCachedPasswdClass ClickCachedPasswdClass;
typedef struct _ClickCachedPasswdPrivate ClickCachedPasswdPrivate;
enum  {
	CLICK_CACHED_PASSWD_0_PROPERTY,
	CLICK_CACHED_PASSWD_NUM_PROPERTIES
};
static GParamSpec* click_cached_passwd_properties[CLICK_CACHED_PASSWD_NUM_PROPERTIES];
enum  {
	CLICK_USERS_0_PROPERTY,
	CLICK_USERS_DB_PROPERTY,
	CLICK_USERS_NUM_PROPERTIES
};
static GParamSpec* click_users_properties[CLICK_USERS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define CLICK_DIR_TYPE_ITERATOR (click_dir_iterator_get_type ())
#define CLICK_DIR_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLICK_DIR_TYPE_ITERATOR, ClickDirIterator))
#define CLICK_DIR_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLICK_DIR_TYPE_ITERATOR, ClickDirIteratorClass))
#define CLICK_DIR_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLICK_DIR_TYPE_ITERATOR))
#define CLICK_DIR_IS_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLICK_DIR_TYPE_ITERATOR))
#define CLICK_DIR_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLICK_DIR_TYPE_ITERATOR, ClickDirIteratorClass))

typedef struct _ClickDirIterator ClickDirIterator;
typedef struct _ClickDirIteratorClass ClickDirIteratorClass;
enum  {
	CLICK_USER_0_PROPERTY,
	CLICK_USER_DB_PROPERTY,
	CLICK_USER_NAME_PROPERTY,
	CLICK_USER_IS_PSEUDO_USER_PROPERTY,
	CLICK_USER_IS_GC_IN_USE_PROPERTY,
	CLICK_USER_NUM_PROPERTIES
};
static GParamSpec* click_user_properties[CLICK_USER_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ClickLogindUser {
	guint32 uid;
	gchar* name;
	gchar* ObjectPath;
};

struct _ClickLogindManagerIface {
	GTypeInterface parent_iface;
	ClickLogindUser* (*ListUsers) (ClickLogindManager* self, gint* result_length1, GError** error);
};

struct _ClickASUserIface {
	GTypeInterface parent_iface;
	gboolean (*get_system_account) (ClickASUser* self);
};

struct _ClickCachedPasswd {
	GObject parent_instance;
	ClickCachedPasswdPrivate * priv;
	uid_t uid;
	gid_t gid;
};

struct _ClickCachedPasswdClass {
	GObjectClass parent_class;
};

struct _ClickUsersPrivate {
	ClickDB* _db;
	ClickCachedPasswd* click_pw;
};

struct _ClickUserPrivate {
	ClickDB* _db;
	gchar* _name;
	ClickUsers* users;
	ClickCachedPasswd* user_pw;
	gint dropped_privileges_count;
	mode_t* old_umask;
};

static gpointer click_cached_passwd_parent_class = NULL;
static gint ClickUsers_private_offset;
static gpointer click_users_parent_class = NULL;
static gint ClickUser_private_offset;
static gpointer click_user_parent_class = NULL;

VALA_EXTERN GType click_logind_user_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ClickLogindUser* click_logind_user_dup (const ClickLogindUser* self);
VALA_EXTERN void click_logind_user_free (ClickLogindUser* self);
VALA_EXTERN void click_logind_user_copy (const ClickLogindUser* self,
                             ClickLogindUser* dest);
VALA_EXTERN void click_logind_user_destroy (ClickLogindUser* self);
VALA_EXTERN GType click_logind_manager_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint click_logind_manager_register_object (void* object,
                                            GDBusConnection* connection,
                                            const gchar* path,
                                            GError** error);
VALA_EXTERN GType click_logind_manager_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ClickLogindUser* click_logind_manager_ListUsers (ClickLogindManager* self,
                                                 gint* result_length1,
                                                 GError** error);
static GType click_logind_manager_get_type_once (void);
static void click_logind_manager_proxy_g_signal (GDBusProxy* proxy,
                                          const gchar* sender_name,
                                          const gchar* signal_name,
                                          GVariant* parameters);
static ClickLogindUser* click_logind_manager_proxy_ListUsers (ClickLogindManager* self,
                                                       gint* result_length1,
                                                       GError** error);
static void click_logind_manager_proxy_click_logind_manager_interface_init (ClickLogindManagerIface* iface);
static void _vala_ClickLogindUser_array_free (ClickLogindUser * array,
                                       gssize array_length);
static void _dbus_click_logind_manager_ListUsers (ClickLogindManager* self,
                                           GVariant* _parameters_,
                                           GDBusMethodInvocation* invocation);
static void click_logind_manager_dbus_interface_method_call (GDBusConnection* connection,
                                                      const gchar* sender,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* method_name,
                                                      GVariant* parameters,
                                                      GDBusMethodInvocation* invocation,
                                                      gpointer user_data);
static GVariant* click_logind_manager_dbus_interface_get_property (GDBusConnection* connection,
                                                            const gchar* sender,
                                                            const gchar* object_path,
                                                            const gchar* interface_name,
                                                            const gchar* property_name,
                                                            GError** error,
                                                            gpointer user_data);
static gboolean click_logind_manager_dbus_interface_set_property (GDBusConnection* connection,
                                                           const gchar* sender,
                                                           const gchar* object_path,
                                                           const gchar* interface_name,
                                                           const gchar* property_name,
                                                           GVariant* value,
                                                           GError** error,
                                                           gpointer user_data);
static void _click_logind_manager_unregister_object (gpointer user_data);
VALA_EXTERN GType click_as_user_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType click_as_user_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint click_as_user_register_object (void* object,
                                     GDBusConnection* connection,
                                     const gchar* path,
                                     GError** error);
VALA_EXTERN gboolean click_as_user_get_system_account (ClickASUser* self);
static GType click_as_user_get_type_once (void);
static void click_as_user_proxy_g_signal (GDBusProxy* proxy,
                                   const gchar* sender_name,
                                   const gchar* signal_name,
                                   GVariant* parameters);
static gboolean click_as_user_dbus_proxy_get_system_account (ClickASUser* self);
static void click_as_user_proxy_click_as_user_interface_init (ClickASUserIface* iface);
static void click_as_user_dbus_interface_method_call (GDBusConnection* connection,
                                               const gchar* sender,
                                               const gchar* object_path,
                                               const gchar* interface_name,
                                               const gchar* method_name,
                                               GVariant* parameters,
                                               GDBusMethodInvocation* invocation,
                                               gpointer user_data);
static GVariant* click_as_user_dbus_interface_get_property (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* property_name,
                                                     GError** error,
                                                     gpointer user_data);
static GVariant* _dbus_click_as_user_get_system_account (ClickASUser* self);
static gboolean click_as_user_dbus_interface_set_property (GDBusConnection* connection,
                                                    const gchar* sender,
                                                    const gchar* object_path,
                                                    const gchar* interface_name,
                                                    const gchar* property_name,
                                                    GVariant* value,
                                                    GError** error,
                                                    gpointer user_data);
static void _click_as_user_unregister_object (gpointer user_data);
VALA_EXTERN gchar* click_db_top (const gchar* root);
VALA_EXTERN gchar* click_db_for_user (const gchar* root,
                          const gchar* user);
VALA_EXTERN void click_try_create (const gchar* path,
                       GError** error);
VALA_EXTERN GType click_cached_passwd_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ClickCachedPasswd* click_cached_passwd_new (uid_t uid,
                                            gid_t gid);
VALA_EXTERN ClickCachedPasswd* click_cached_passwd_construct (GType object_type,
                                                  uid_t uid,
                                                  gid_t gid);
static void click_cached_passwd_finalize (GObject * obj);
static GType click_cached_passwd_get_type_once (void);
VALA_EXTERN void click_try_chown (const gchar* path,
                      ClickCachedPasswd* pw,
                      GError** error);
static ClickCachedPasswd* click_users_get_click_pw (ClickUsers* self,
                                             GError** error);
VALA_EXTERN void click_users_ensure_db (ClickUsers* self,
                            GError** error);
static ClickDB* click_users_get_db (ClickUsers* self);
VALA_EXTERN gboolean click_exists (const gchar* path);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
VALA_EXTERN GType click_dir_iterator_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ClickDirIterator* click_dir_iterator (ClickDir* self);
VALA_EXTERN const gchar* click_dir_iterator_next_value (ClickDirIterator* self);
VALA_EXTERN gboolean click_is_dir (const gchar* path);
static void click_users_finalize (GObject * obj);
static GType click_users_get_type_once (void);
static void _vala_click_users_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_click_users_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static ClickUser* click_user_new (ClickDB* db,
                           const gchar* name,
                           GError** error);
static ClickUser* click_user_construct (GType object_type,
                                 ClickDB* db,
                                 const gchar* name,
                                 GError** error);
static ClickCachedPasswd* click_user_get_user_pw (ClickUser* self,
                                           GError** error);
static const gchar* click_user_get_name (ClickUser* self);
static ClickDB* click_user_get_db (ClickUser* self);
static void click_user_ensure_db (ClickUser* self,
                           GError** error);
static void click_user_priv_drop_failure (ClickUser* self,
                                   const gchar* name,
                                   GError** error);
VALA_EXTERN void click_user_drop_privileges (ClickUser* self,
                                 GError** error);
static mode_t* _mode_t_dup (mode_t* self);
static void click_user_priv_regain_failure (ClickUser* self,
                                     const gchar* name);
VALA_EXTERN void click_user_regain_privileges (ClickUser* self);
static gboolean click_user_is_valid_link (ClickUser* self,
                                   const gchar* path);
VALA_EXTERN gboolean click_is_symlink (const gchar* path);
static GList* click_user_get_package_names_dropped (ClickUser* self,
                                             GError** error);
VALA_EXTERN void click_user_raw_set_version (ClickUser* self,
                                 const gchar* package,
                                 const gchar* version,
                                 GError** error);
static void click_user_run_user_install_hooks_for_all_logged_in_users (ClickUser* self,
                                                                const gchar* package,
                                                                const gchar* old_version,
                                                                const gchar* version,
                                                                GError** error);
static gchar** click_user_get_logged_in_users (ClickUser* self,
                                        gint* result_length1);
static void _vala_array_add12 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void click_user_run_user_remove_hooks_for_all_logged_in_users (ClickUser* self,
                                                               const gchar* package,
                                                               const gchar* old_version,
                                                               GError** error);
static gchar* click_user_get_dbus_session_bus_env_for_current_user (ClickUser* self);
static gboolean click_user_stop_single_app (ClickUser* self,
                                     const gchar* app_id);
static void _vala_array_add13 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static gboolean click_user_stop_running_apps_for_package (ClickUser* self,
                                                   const gchar* package,
                                                   const gchar* version);
static void click_user_package_remove_user_cache (ClickUser* self,
                                           const gchar* package,
                                           GError** error);
static void _vala_JsonNode_free (JsonNode* self);
static void click_user_finalize (GObject * obj);
static GType click_user_get_type_once (void);
static void _vala_click_user_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_click_user_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GDBusArgInfo _click_logind_manager_dbus_arg_info_ListUsers_result = {-1, "result", "a(uss)", NULL};
static const GDBusArgInfo * const _click_logind_manager_dbus_arg_info_ListUsers_in[] = {NULL};
static const GDBusArgInfo * const _click_logind_manager_dbus_arg_info_ListUsers_out[] = {&_click_logind_manager_dbus_arg_info_ListUsers_result, NULL};
static const GDBusMethodInfo _click_logind_manager_dbus_method_info_ListUsers = {-1, "ListUsers", (GDBusArgInfo **) (&_click_logind_manager_dbus_arg_info_ListUsers_in), (GDBusArgInfo **) (&_click_logind_manager_dbus_arg_info_ListUsers_out), NULL};
static const GDBusMethodInfo * const _click_logind_manager_dbus_method_info[] = {&_click_logind_manager_dbus_method_info_ListUsers, NULL};
static const GDBusSignalInfo * const _click_logind_manager_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _click_logind_manager_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _click_logind_manager_dbus_interface_info = {-1, "org.freedesktop.login1.Manager", (GDBusMethodInfo **) (&_click_logind_manager_dbus_method_info), (GDBusSignalInfo **) (&_click_logind_manager_dbus_signal_info), (GDBusPropertyInfo **) (&_click_logind_manager_dbus_property_info), NULL};
static const GDBusInterfaceVTable _click_logind_manager_dbus_interface_vtable = {click_logind_manager_dbus_interface_method_call, click_logind_manager_dbus_interface_get_property, click_logind_manager_dbus_interface_set_property};
static const GDBusMethodInfo * const _click_as_user_dbus_method_info[] = {NULL};
static const GDBusSignalInfo * const _click_as_user_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _click_as_user_dbus_property_info_system_account = {-1, "SystemAccount", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _click_as_user_dbus_property_info[] = {&_click_as_user_dbus_property_info_system_account, NULL};
static const GDBusInterfaceInfo _click_as_user_dbus_interface_info = {-1, "org.freedesktop.Accounts.User", (GDBusMethodInfo **) (&_click_as_user_dbus_method_info), (GDBusSignalInfo **) (&_click_as_user_dbus_signal_info), (GDBusPropertyInfo **) (&_click_as_user_dbus_property_info), NULL};
static const GDBusInterfaceVTable _click_as_user_dbus_interface_vtable = {click_as_user_dbus_interface_method_call, click_as_user_dbus_interface_get_property, click_as_user_dbus_interface_set_property};

void
click_logind_user_copy (const ClickLogindUser* self,
                        ClickLogindUser* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	(*dest).uid = (*self).uid;
	_tmp0_ = (*self).name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).name);
	(*dest).name = _tmp1_;
	_tmp2_ = (*self).ObjectPath;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).ObjectPath);
	(*dest).ObjectPath = _tmp3_;
}

void
click_logind_user_destroy (ClickLogindUser* self)
{
	_g_free0 ((*self).name);
	_g_free0 ((*self).ObjectPath);
}

ClickLogindUser*
click_logind_user_dup (const ClickLogindUser* self)
{
	ClickLogindUser* dup;
	dup = g_new0 (ClickLogindUser, 1);
	click_logind_user_copy (self, dup);
	return dup;
}

void
click_logind_user_free (ClickLogindUser* self)
{
	click_logind_user_destroy (self);
	g_free (self);
}

static GType
click_logind_user_get_type_once (void)
{
	GType click_logind_user_type_id;
	click_logind_user_type_id = g_boxed_type_register_static ("ClickLogindUser", (GBoxedCopyFunc) click_logind_user_dup, (GBoxedFreeFunc) click_logind_user_free);
	return click_logind_user_type_id;
}

GType
click_logind_user_get_type (void)
{
	static volatile gsize click_logind_user_type_id__once = 0;
	if (g_once_init_enter (&click_logind_user_type_id__once)) {
		GType click_logind_user_type_id;
		click_logind_user_type_id = click_logind_user_get_type_once ();
		g_once_init_leave (&click_logind_user_type_id__once, click_logind_user_type_id);
	}
	return click_logind_user_type_id__once;
}

ClickLogindUser*
click_logind_manager_ListUsers (ClickLogindManager* self,
                                gint* result_length1,
                                GError** error)
{
	ClickLogindManagerIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = CLICK_LOGIND_MANAGER_GET_INTERFACE (self);
	if (_iface_->ListUsers) {
		return _iface_->ListUsers (self, result_length1, error);
	}
	return NULL;
}

static void
click_logind_manager_default_init (ClickLogindManagerIface * iface,
                                   gpointer iface_data)
{
}

static GType
click_logind_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClickLogindManagerIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) click_logind_manager_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType click_logind_manager_type_id;
	click_logind_manager_type_id = g_type_register_static (G_TYPE_INTERFACE, "ClickLogindManager", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (click_logind_manager_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (click_logind_manager_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) click_logind_manager_proxy_get_type);
	g_type_set_qdata (click_logind_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.login1.Manager");
	g_type_set_qdata (click_logind_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_click_logind_manager_dbus_interface_info));
	g_type_set_qdata (click_logind_manager_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) click_logind_manager_register_object);
	return click_logind_manager_type_id;
}

GType
click_logind_manager_get_type (void)
{
	static volatile gsize click_logind_manager_type_id__once = 0;
	if (g_once_init_enter (&click_logind_manager_type_id__once)) {
		GType click_logind_manager_type_id;
		click_logind_manager_type_id = click_logind_manager_get_type_once ();
		g_once_init_leave (&click_logind_manager_type_id__once, click_logind_manager_type_id);
	}
	return click_logind_manager_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (ClickLogindManagerProxy, click_logind_manager_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (CLICK_TYPE_LOGIND_MANAGER, click_logind_manager_proxy_click_logind_manager_interface_init) )
static void
click_logind_manager_proxy_class_init (ClickLogindManagerProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = click_logind_manager_proxy_g_signal;
}

static void
click_logind_manager_proxy_g_signal (GDBusProxy* proxy,
                                     const gchar* sender_name,
                                     const gchar* signal_name,
                                     GVariant* parameters)
{
}

static void
click_logind_manager_proxy_init (ClickLogindManagerProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_click_logind_manager_dbus_interface_info));
}

static ClickLogindUser*
click_logind_manager_proxy_ListUsers (ClickLogindManager* self,
                                      gint* result_length1,
                                      GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	ClickLogindUser* _result = NULL;
	gint _result_length1;
	GVariant* _tmp0_;
	ClickLogindUser* _tmp1_;
	gint _tmp1__length;
	gint _tmp1__size;
	gint _tmp1__length1;
	GVariantIter _tmp2_;
	GVariant* _tmp3_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.login1.Manager", "ListUsers");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp0_ = g_variant_iter_next_value (&_reply_iter);
	_tmp1_ = g_new (ClickLogindUser, 5);
	_tmp1__length = 0;
	_tmp1__size = 4;
	_tmp1__length1 = 0;
	g_variant_iter_init (&_tmp2_, _tmp0_);
	for (; (_tmp3_ = g_variant_iter_next_value (&_tmp2_)) != NULL; _tmp1__length1++) {
		ClickLogindUser _tmp4_;
		GVariantIter _tmp5_;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		GVariant* _tmp8_;
		if (_tmp1__size == _tmp1__length) {
			_tmp1__size = 2 * _tmp1__size;
			_tmp1_ = g_renew (ClickLogindUser, _tmp1_, _tmp1__size + 1);
		}
		g_variant_iter_init (&_tmp5_, _tmp3_);
		_tmp6_ = g_variant_iter_next_value (&_tmp5_);
		_tmp4_.uid = g_variant_get_uint32 (_tmp6_);
		g_variant_unref (_tmp6_);
		_tmp7_ = g_variant_iter_next_value (&_tmp5_);
		_tmp4_.name = g_variant_dup_string (_tmp7_, NULL);
		g_variant_unref (_tmp7_);
		_tmp8_ = g_variant_iter_next_value (&_tmp5_);
		_tmp4_.ObjectPath = g_variant_dup_string (_tmp8_, NULL);
		g_variant_unref (_tmp8_);
		_tmp1_[_tmp1__length++] = _tmp4_;
		g_variant_unref (_tmp3_);
	}
	_result_length1 = _tmp1__length1;
	_result = _tmp1_;
	g_variant_unref (_tmp0_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}

static void
click_logind_manager_proxy_click_logind_manager_interface_init (ClickLogindManagerIface* iface)
{
	iface->ListUsers = click_logind_manager_proxy_ListUsers;
}

static void
_vala_ClickLogindUser_array_free (ClickLogindUser * array,
                                  gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			click_logind_user_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_dbus_click_logind_manager_ListUsers (ClickLogindManager* self,
                                      GVariant* _parameters_,
                                      GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	ClickLogindUser* result;
	gint result_length1 = 0;
	ClickLogindUser* _tmp9_;
	GVariantBuilder _tmp10_;
	gint _tmp11_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = click_logind_manager_ListUsers (self, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp9_ = result;
	g_variant_builder_init (&_tmp10_, G_VARIANT_TYPE ("a(uss)"));
	for (_tmp11_ = 0; _tmp11_ < result_length1; _tmp11_++) {
		GVariantBuilder _tmp12_;
		g_variant_builder_init (&_tmp12_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp12_, g_variant_new_uint32 ((*_tmp9_).uid));
		g_variant_builder_add_value (&_tmp12_, g_variant_new_string ((*_tmp9_).name));
		g_variant_builder_add_value (&_tmp12_, g_variant_new_string ((*_tmp9_).ObjectPath));
		g_variant_builder_add_value (&_tmp10_, g_variant_builder_end (&_tmp12_));
		_tmp9_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp10_));
	result = (_vala_ClickLogindUser_array_free (result, result_length1), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
click_logind_manager_dbus_interface_method_call (GDBusConnection* connection,
                                                 const gchar* sender,
                                                 const gchar* object_path,
                                                 const gchar* interface_name,
                                                 const gchar* method_name,
                                                 GVariant* parameters,
                                                 GDBusMethodInvocation* invocation,
                                                 gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "ListUsers") == 0) {
		_dbus_click_logind_manager_ListUsers (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
click_logind_manager_dbus_interface_get_property (GDBusConnection* connection,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* property_name,
                                                  GError** error,
                                                  gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
click_logind_manager_dbus_interface_set_property (GDBusConnection* connection,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* property_name,
                                                  GVariant* value,
                                                  GError** error,
                                                  gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
click_logind_manager_register_object (gpointer object,
                                      GDBusConnection* connection,
                                      const gchar* path,
                                      GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_click_logind_manager_dbus_interface_info), &_click_logind_manager_dbus_interface_vtable, data, _click_logind_manager_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_click_logind_manager_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

gboolean
click_as_user_get_system_account (ClickASUser* self)
{
	ClickASUserIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = CLICK_AS_USER_GET_INTERFACE (self);
	if (_iface_->get_system_account) {
		return _iface_->get_system_account (self);
	}
	return FALSE;
}

static void
click_as_user_default_init (ClickASUserIface * iface,
                            gpointer iface_data)
{
}

static GType
click_as_user_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClickASUserIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) click_as_user_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType click_as_user_type_id;
	click_as_user_type_id = g_type_register_static (G_TYPE_INTERFACE, "ClickASUser", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (click_as_user_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (click_as_user_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) click_as_user_proxy_get_type);
	g_type_set_qdata (click_as_user_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.Accounts.User");
	g_type_set_qdata (click_as_user_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_click_as_user_dbus_interface_info));
	g_type_set_qdata (click_as_user_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) click_as_user_register_object);
	return click_as_user_type_id;
}

GType
click_as_user_get_type (void)
{
	static volatile gsize click_as_user_type_id__once = 0;
	if (g_once_init_enter (&click_as_user_type_id__once)) {
		GType click_as_user_type_id;
		click_as_user_type_id = click_as_user_get_type_once ();
		g_once_init_leave (&click_as_user_type_id__once, click_as_user_type_id);
	}
	return click_as_user_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (ClickASUserProxy, click_as_user_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (CLICK_TYPE_AS_USER, click_as_user_proxy_click_as_user_interface_init) )
static void
click_as_user_proxy_class_init (ClickASUserProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = click_as_user_proxy_g_signal;
}

static void
click_as_user_proxy_g_signal (GDBusProxy* proxy,
                              const gchar* sender_name,
                              const gchar* signal_name,
                              GVariant* parameters)
{
}

static void
click_as_user_proxy_init (ClickASUserProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_click_as_user_dbus_interface_info));
}

static gboolean
click_as_user_dbus_proxy_get_system_account (ClickASUser* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "SystemAccount");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.freedesktop.Accounts.User"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("SystemAccount"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp13_ = FALSE;
			return _tmp13_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static void
click_as_user_proxy_click_as_user_interface_init (ClickASUserIface* iface)
{
	iface->get_system_account = click_as_user_dbus_proxy_get_system_account;
}

static void
click_as_user_dbus_interface_method_call (GDBusConnection* connection,
                                          const gchar* sender,
                                          const gchar* object_path,
                                          const gchar* interface_name,
                                          const gchar* method_name,
                                          GVariant* parameters,
                                          GDBusMethodInvocation* invocation,
                                          gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	g_object_unref (invocation);
}

static GVariant*
_dbus_click_as_user_get_system_account (ClickASUser* self)
{
	gboolean result;
	GVariant* _reply;
	result = click_as_user_get_system_account (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
click_as_user_dbus_interface_get_property (GDBusConnection* connection,
                                           const gchar* sender,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* property_name,
                                           GError** error,
                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "SystemAccount") == 0) {
		return _dbus_click_as_user_get_system_account (object);
	}
	return NULL;
}

static gboolean
click_as_user_dbus_interface_set_property (GDBusConnection* connection,
                                           const gchar* sender,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* property_name,
                                           GVariant* value,
                                           GError** error,
                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
click_as_user_register_object (gpointer object,
                               GDBusConnection* connection,
                               const gchar* path,
                               GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_click_as_user_dbus_interface_info), &_click_as_user_dbus_interface_vtable, data, _click_as_user_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_click_as_user_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

GQuark
click_user_error_quark (void)
{
	return g_quark_from_static_string ("click-user-error-quark");
}

static GType
click_user_error_get_type_once (void)
{
	static const GEnumValue values[] = {{CLICK_USER_ERROR_GETPWNAM, "CLICK_USER_ERROR_GETPWNAM", "getpwnam"}, {CLICK_USER_ERROR_CREATE_DB, "CLICK_USER_ERROR_CREATE_DB", "create-db"}, {CLICK_USER_ERROR_CHOWN_DB, "CLICK_USER_ERROR_CHOWN_DB", "chown-db"}, {CLICK_USER_ERROR_NO_SUCH_USER, "CLICK_USER_ERROR_NO_SUCH_USER", "no-such-user"}, {CLICK_USER_ERROR_DROP_PRIVS, "CLICK_USER_ERROR_DROP_PRIVS", "drop-privs"}, {CLICK_USER_ERROR_REGAIN_PRIVS, "CLICK_USER_ERROR_REGAIN_PRIVS", "regain-privs"}, {CLICK_USER_ERROR_HIDDEN_PACKAGE, "CLICK_USER_ERROR_HIDDEN_PACKAGE", "hidden-package"}, {CLICK_USER_ERROR_NO_SUCH_PACKAGE, "CLICK_USER_ERROR_NO_SUCH_PACKAGE", "no-such-package"}, {CLICK_USER_ERROR_RENAME, "CLICK_USER_ERROR_RENAME", "rename"}, {0, NULL, NULL}};
	GType click_user_error_type_id;
	click_user_error_type_id = g_enum_register_static ("ClickUserError", values);
	return click_user_error_type_id;
}

GType
click_user_error_get_type (void)
{
	static volatile gsize click_user_error_type_id__once = 0;
	if (g_once_init_enter (&click_user_error_type_id__once)) {
		GType click_user_error_type_id;
		click_user_error_type_id = click_user_error_get_type_once ();
		g_once_init_leave (&click_user_error_type_id__once, click_user_error_type_id);
	}
	return click_user_error_type_id__once;
}

gchar*
click_db_top (const gchar* root)
{
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (root != NULL, NULL);
	_tmp0_ = g_build_filename (root, ".click", "users", NULL);
	result = _tmp0_;
	return result;
}

gchar*
click_db_for_user (const gchar* root,
                   const gchar* user)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
	g_return_val_if_fail (root != NULL, NULL);
	g_return_val_if_fail (user != NULL, NULL);
	_tmp0_ = click_db_top (root);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_build_filename (_tmp1_, user, NULL);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	result = _tmp3_;
	return result;
}

void
click_try_create (const gchar* path,
                  GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (path != NULL);
	if (g_mkdir (path, 0777) < 0) {
		const gchar* _tmp0_;
		GError* _tmp1_;
		_tmp0_ = g_strerror (errno);
		_tmp1_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_CREATE_DB, "Cannot create database directory %s: %s", path, _tmp0_);
		_inner_error0_ = _tmp1_;
		if (_inner_error0_->domain == CLICK_USER_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

ClickCachedPasswd*
click_cached_passwd_construct (GType object_type,
                               uid_t uid,
                               gid_t gid)
{
	ClickCachedPasswd * self = NULL;
	self = (ClickCachedPasswd*) g_object_new (object_type, NULL);
	self->uid = uid;
	self->gid = gid;
	return self;
}

ClickCachedPasswd*
click_cached_passwd_new (uid_t uid,
                         gid_t gid)
{
	return click_cached_passwd_construct (CLICK_TYPE_CACHED_PASSWD, uid, gid);
}

static void
click_cached_passwd_class_init (ClickCachedPasswdClass * klass,
                                gpointer klass_data)
{
	click_cached_passwd_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = click_cached_passwd_finalize;
}

static void
click_cached_passwd_instance_init (ClickCachedPasswd * self,
                                   gpointer klass)
{
}

static void
click_cached_passwd_finalize (GObject * obj)
{
	ClickCachedPasswd * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLICK_TYPE_CACHED_PASSWD, ClickCachedPasswd);
	G_OBJECT_CLASS (click_cached_passwd_parent_class)->finalize (obj);
}

static GType
click_cached_passwd_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClickCachedPasswdClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) click_cached_passwd_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClickCachedPasswd), 0, (GInstanceInitFunc) click_cached_passwd_instance_init, NULL };
	GType click_cached_passwd_type_id;
	click_cached_passwd_type_id = g_type_register_static (G_TYPE_OBJECT, "ClickCachedPasswd", &g_define_type_info, 0);
	return click_cached_passwd_type_id;
}

GType
click_cached_passwd_get_type (void)
{
	static volatile gsize click_cached_passwd_type_id__once = 0;
	if (g_once_init_enter (&click_cached_passwd_type_id__once)) {
		GType click_cached_passwd_type_id;
		click_cached_passwd_type_id = click_cached_passwd_get_type_once ();
		g_once_init_leave (&click_cached_passwd_type_id__once, click_cached_passwd_type_id);
	}
	return click_cached_passwd_type_id__once;
}

void
click_try_chown (const gchar* path,
                 ClickCachedPasswd* pw,
                 GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (path != NULL);
	g_return_if_fail (pw != NULL);
	if (chown (path, pw->uid, pw->gid) < 0) {
		const gchar* _tmp0_;
		GError* _tmp1_;
		_tmp0_ = g_strerror (errno);
		_tmp1_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_CHOWN_DB, "Cannot set ownership of database directory %s: %s", path, _tmp0_);
		_inner_error0_ = _tmp1_;
		if (_inner_error0_->domain == CLICK_USER_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

static inline gpointer
click_users_get_instance_private (ClickUsers* self)
{
	return G_STRUCT_MEMBER_P (self, ClickUsers_private_offset);
}

ClickUsers*
click_users_construct (GType object_type,
                       ClickDB* db)
{
	ClickUsers * self = NULL;
	g_return_val_if_fail (db != NULL, NULL);
	self = (ClickUsers*) g_object_new (object_type, "db", db, NULL);
	_g_object_unref0 (self->priv->click_pw);
	self->priv->click_pw = NULL;
	return self;
}

ClickUsers*
click_users_new (ClickDB* db)
{
	return click_users_construct (CLICK_TYPE_USERS, db);
}

/**
 * get_click_pw:
 *
 * Returns: The password file entry for the `clickpkg` user.
 */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static ClickCachedPasswd*
click_users_get_click_pw (ClickUsers* self,
                          GError** error)
{
	ClickCachedPasswd* _tmp0_;
	ClickCachedPasswd* _tmp8_;
	ClickCachedPasswd* _tmp9_;
	GError* _inner_error0_ = NULL;
	ClickCachedPasswd* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->click_pw;
	if (_tmp0_ == NULL) {
		struct passwd* pw = NULL;
		struct passwd* _tmp1_;
		struct passwd* _tmp2_;
		struct passwd* _tmp5_;
		struct passwd* _tmp6_;
		ClickCachedPasswd* _tmp7_;
		errno = 0;
		_tmp1_ = getpwnam ("clickpkg");
		pw = _tmp1_;
		_tmp2_ = pw;
		if (_tmp2_ == NULL) {
			const gchar* _tmp3_;
			GError* _tmp4_;
			_tmp3_ = g_strerror (errno);
			_tmp4_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_GETPWNAM, "Cannot get password file entry " "for clickpkg: %s", _tmp3_);
			_inner_error0_ = _tmp4_;
			if (_inner_error0_->domain == CLICK_USER_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp5_ = pw;
		_tmp6_ = pw;
		_tmp7_ = click_cached_passwd_new (_tmp5_->pw_uid, _tmp6_->pw_gid);
		_g_object_unref0 (self->priv->click_pw);
		self->priv->click_pw = _tmp7_;
	}
	_tmp8_ = self->priv->click_pw;
	_tmp9_ = _g_object_ref0 (_tmp8_);
	result = _tmp9_;
	return result;
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
}

void
click_users_ensure_db (ClickUsers* self,
                       GError** error)
{
	GList* create = NULL;
	gchar* try_path = NULL;
	ClickDB* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GList* _tmp9_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	create = NULL;
	_tmp0_ = self->priv->_db;
	_tmp1_ = click_db_get_overlay (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = click_db_top (_tmp2_);
	try_path = _tmp3_;
	while (TRUE) {
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		_tmp4_ = try_path;
		if (!(!click_exists (_tmp4_))) {
			break;
		}
		_tmp5_ = try_path;
		_tmp6_ = g_strdup (_tmp5_);
		create = g_list_prepend (create, _tmp6_);
		_tmp7_ = try_path;
		_tmp8_ = g_path_get_dirname (_tmp7_);
		_g_free0 (try_path);
		try_path = _tmp8_;
	}
	_tmp9_ = create;
	{
		GList* path_collection = NULL;
		GList* path_it = NULL;
		path_collection = _tmp9_;
		for (path_it = path_collection; path_it != NULL; path_it = path_it->next) {
			gchar* _tmp10_;
			gchar* path = NULL;
			_tmp10_ = g_strdup ((const gchar*) path_it->data);
			path = _tmp10_;
			{
				const gchar* _tmp11_;
				_tmp11_ = path;
				click_try_create (_tmp11_, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == CLICK_USER_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_g_free0 (path);
						_g_free0 (try_path);
						(create == NULL) ? NULL : (create = (_g_list_free__g_free0_ (create), NULL));
						return;
					} else {
						_g_free0 (path);
						_g_free0 (try_path);
						(create == NULL) ? NULL : (create = (_g_list_free__g_free0_ (create), NULL));
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				if (geteuid () == ((uid_t) 0)) {
					ClickCachedPasswd* _tmp12_ = NULL;
					ClickCachedPasswd* _tmp13_;
					const gchar* _tmp14_;
					_tmp13_ = click_users_get_click_pw (self, &_inner_error0_);
					_tmp12_ = _tmp13_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == CLICK_USER_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_g_free0 (path);
							_g_free0 (try_path);
							(create == NULL) ? NULL : (create = (_g_list_free__g_free0_ (create), NULL));
							return;
						} else {
							_g_free0 (path);
							_g_free0 (try_path);
							(create == NULL) ? NULL : (create = (_g_list_free__g_free0_ (create), NULL));
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
					}
					_tmp14_ = path;
					click_try_chown (_tmp14_, _tmp12_, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == CLICK_USER_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_g_object_unref0 (_tmp12_);
							_g_free0 (path);
							_g_free0 (try_path);
							(create == NULL) ? NULL : (create = (_g_list_free__g_free0_ (create), NULL));
							return;
						} else {
							_g_object_unref0 (_tmp12_);
							_g_free0 (path);
							_g_free0 (try_path);
							(create == NULL) ? NULL : (create = (_g_list_free__g_free0_ (create), NULL));
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
					}
					_g_object_unref0 (_tmp12_);
				}
				_g_free0 (path);
			}
		}
	}
	_g_free0 (try_path);
	(create == NULL) ? NULL : (create = (_g_list_free__g_free0_ (create), NULL));
}

/**
 * get_user_names:
 *
 * Returns: A list of user names with registrations.
 */
GList*
click_users_get_user_names (ClickUsers* self,
                            GError** error)
{
	GList* entries = NULL;
	GeeHashSet* seen = NULL;
	GeeHashSet* _tmp0_;
	GError* _inner_error0_ = NULL;
	GList* result;
	g_return_val_if_fail (self != NULL, NULL);
	entries = NULL;
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
	seen = _tmp0_;
	{
		ClickDB* _single_db_list = NULL;
		ClickDB* _tmp1_;
		gint _single_db_size = 0;
		ClickDB* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _single_db_index = 0;
		_tmp1_ = self->priv->_db;
		_single_db_list = _tmp1_;
		_tmp2_ = _single_db_list;
		_tmp3_ = click_db_get_size (_tmp2_);
		_tmp4_ = _tmp3_;
		_single_db_size = _tmp4_;
		_single_db_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			ClickSingleDB* single_db = NULL;
			ClickDB* _tmp7_;
			ClickSingleDB* _tmp8_;
			gchar* users_db = NULL;
			ClickSingleDB* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			ClickDir* _tmp13_ = NULL;
			const gchar* _tmp14_;
			ClickDir* _tmp15_;
			_single_db_index = _single_db_index + 1;
			_tmp5_ = _single_db_index;
			_tmp6_ = _single_db_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _single_db_list;
			_tmp8_ = click_db_get (_tmp7_, _single_db_index, &_inner_error0_);
			single_db = _tmp8_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (seen);
				(entries == NULL) ? NULL : (entries = (_g_list_free__g_free0_ (entries), NULL));
				return NULL;
			}
			_tmp9_ = single_db;
			_tmp10_ = click_single_db_get_root (_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp12_ = click_db_top (_tmp11_);
			users_db = _tmp12_;
			_tmp14_ = users_db;
			_tmp15_ = click_dir_open (_tmp14_, (guint) 0, &_inner_error0_);
			_tmp13_ = _tmp15_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (users_db);
				_g_object_unref0 (single_db);
				_g_object_unref0 (seen);
				(entries == NULL) ? NULL : (entries = (_g_list_free__g_free0_ (entries), NULL));
				return NULL;
			}
			{
				ClickDirIterator* _entry_it = NULL;
				ClickDirIterator* _tmp16_;
				const gchar* entry = NULL;
				_tmp16_ = click_dir_iterator (_tmp13_);
				_entry_it = _tmp16_;
				while (TRUE) {
					ClickDirIterator* _tmp17_;
					const gchar* _tmp18_;
					const gchar* _tmp19_;
					GeeHashSet* _tmp20_;
					const gchar* _tmp21_;
					gboolean _tmp22_ = FALSE;
					const gchar* _tmp23_;
					gchar* path = NULL;
					const gchar* _tmp26_;
					const gchar* _tmp27_;
					gchar* _tmp28_;
					const gchar* _tmp29_;
					_tmp17_ = _entry_it;
					_tmp18_ = click_dir_iterator_next_value (_tmp17_);
					entry = _tmp18_;
					_tmp19_ = entry;
					if (!(_tmp19_ != NULL)) {
						break;
					}
					_tmp20_ = seen;
					_tmp21_ = entry;
					if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp20_, _tmp21_)) {
						continue;
					}
					_tmp23_ = entry;
					if (!g_str_has_prefix (_tmp23_, "@")) {
						const gchar* _tmp24_;
						struct passwd* _tmp25_;
						_tmp24_ = entry;
						_tmp25_ = getpwnam (_tmp24_);
						_tmp22_ = _tmp25_ == NULL;
					} else {
						_tmp22_ = FALSE;
					}
					if (_tmp22_) {
						continue;
					}
					_tmp26_ = users_db;
					_tmp27_ = entry;
					_tmp28_ = g_build_filename (_tmp26_, _tmp27_, NULL);
					path = _tmp28_;
					_tmp29_ = path;
					if (click_is_dir (_tmp29_)) {
						GeeHashSet* _tmp30_;
						const gchar* _tmp31_;
						gchar* _tmp32_;
						gchar* _tmp33_;
						const gchar* _tmp34_;
						gchar* _tmp35_;
						_tmp30_ = seen;
						_tmp31_ = entry;
						_tmp32_ = g_strdup (_tmp31_);
						_tmp33_ = _tmp32_;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp33_);
						_g_free0 (_tmp33_);
						_tmp34_ = entry;
						_tmp35_ = g_strdup (_tmp34_);
						entries = g_list_prepend (entries, _tmp35_);
					}
					_g_free0 (path);
				}
				_g_object_unref0 (_entry_it);
			}
			_g_object_unref0 (_tmp13_);
			_g_free0 (users_db);
			_g_object_unref0 (single_db);
		}
	}
	entries = g_list_reverse (entries);
	result = entries;
	_g_object_unref0 (seen);
	return result;
}

/**
 * get_user:
 * @user_name: A user name.
 *
 * Returns: (transfer full): A new #ClickUser instance for @user.
 */
ClickUser*
click_users_get_user (ClickUsers* self,
                      const gchar* user_name,
                      GError** error)
{
	GError* _tmp17_;
	GError* _inner_error0_ = NULL;
	ClickUser* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (user_name != NULL, NULL);
	{
		ClickDB* _single_db_list = NULL;
		ClickDB* _tmp0_;
		gint _single_db_size = 0;
		ClickDB* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _single_db_index = 0;
		_tmp0_ = self->priv->_db;
		_single_db_list = _tmp0_;
		_tmp1_ = _single_db_list;
		_tmp2_ = click_db_get_size (_tmp1_);
		_tmp3_ = _tmp2_;
		_single_db_size = _tmp3_;
		_single_db_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			ClickSingleDB* single_db = NULL;
			ClickDB* _tmp6_;
			ClickSingleDB* _tmp7_;
			gchar* path = NULL;
			ClickSingleDB* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			const gchar* _tmp12_;
			_single_db_index = _single_db_index + 1;
			_tmp4_ = _single_db_index;
			_tmp5_ = _single_db_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _single_db_list;
			_tmp7_ = click_db_get (_tmp6_, _single_db_index, &_inner_error0_);
			single_db = _tmp7_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			}
			_tmp8_ = single_db;
			_tmp9_ = click_single_db_get_root (_tmp8_);
			_tmp10_ = _tmp9_;
			_tmp11_ = click_db_for_user (_tmp10_, user_name);
			path = _tmp11_;
			_tmp12_ = path;
			if (click_is_dir (_tmp12_)) {
				ClickUser* _tmp13_ = NULL;
				ClickDB* _tmp14_;
				ClickUser* _tmp15_;
				ClickUser* _tmp16_;
				_tmp14_ = self->priv->_db;
				_tmp15_ = click_user_new_for_user (_tmp14_, user_name, &_inner_error0_);
				_tmp13_ = _tmp15_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_free0 (path);
					_g_object_unref0 (single_db);
					return NULL;
				}
				_tmp16_ = _tmp13_;
				_tmp13_ = NULL;
				result = _tmp16_;
				_g_object_unref0 (_tmp13_);
				_g_free0 (path);
				_g_object_unref0 (single_db);
				return result;
			}
			_g_free0 (path);
			_g_object_unref0 (single_db);
		}
	}
	_tmp17_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_NO_SUCH_USER, "User %s does not exist in any database", user_name);
	_inner_error0_ = _tmp17_;
	g_propagate_error (error, _inner_error0_);
	return NULL;
}

static ClickDB*
click_users_get_db (ClickUsers* self)
{
	ClickDB* result;
	ClickDB* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_db;
	result = _tmp0_;
	return result;
}

static void
click_users_set_db (ClickUsers* self,
                    ClickDB* value)
{
	ClickDB* old_value;
	g_return_if_fail (self != NULL);
	old_value = click_users_get_db (self);
	if (old_value != value) {
		ClickDB* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_db);
		self->priv->_db = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, click_users_properties[CLICK_USERS_DB_PROPERTY]);
	}
}

static void
click_users_class_init (ClickUsersClass * klass,
                        gpointer klass_data)
{
	click_users_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ClickUsers_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_click_users_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_click_users_set_property;
	G_OBJECT_CLASS (klass)->finalize = click_users_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLICK_USERS_DB_PROPERTY, click_users_properties[CLICK_USERS_DB_PROPERTY] = g_param_spec_object ("db", "db", "db", CLICK_TYPE_DB, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
click_users_instance_init (ClickUsers * self,
                           gpointer klass)
{
	self->priv = click_users_get_instance_private (self);
}

static void
click_users_finalize (GObject * obj)
{
	ClickUsers * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLICK_TYPE_USERS, ClickUsers);
	_g_object_unref0 (self->priv->_db);
	_g_object_unref0 (self->priv->click_pw);
	G_OBJECT_CLASS (click_users_parent_class)->finalize (obj);
}

static GType
click_users_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClickUsersClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) click_users_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClickUsers), 0, (GInstanceInitFunc) click_users_instance_init, NULL };
	GType click_users_type_id;
	click_users_type_id = g_type_register_static (G_TYPE_OBJECT, "ClickUsers", &g_define_type_info, 0);
	ClickUsers_private_offset = g_type_add_instance_private (click_users_type_id, sizeof (ClickUsersPrivate));
	return click_users_type_id;
}

GType
click_users_get_type (void)
{
	static volatile gsize click_users_type_id__once = 0;
	if (g_once_init_enter (&click_users_type_id__once)) {
		GType click_users_type_id;
		click_users_type_id = click_users_get_type_once ();
		g_once_init_leave (&click_users_type_id__once, click_users_type_id);
	}
	return click_users_type_id__once;
}

static void
_vala_click_users_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ClickUsers * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CLICK_TYPE_USERS, ClickUsers);
	switch (property_id) {
		case CLICK_USERS_DB_PROPERTY:
		g_value_set_object (value, click_users_get_db (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_click_users_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	ClickUsers * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CLICK_TYPE_USERS, ClickUsers);
	switch (property_id) {
		case CLICK_USERS_DB_PROPERTY:
		click_users_set_db (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
click_user_get_instance_private (ClickUser* self)
{
	return G_STRUCT_MEMBER_P (self, ClickUser_private_offset);
}

static ClickUser*
click_user_construct (GType object_type,
                      ClickDB* db,
                      const gchar* name,
                      GError** error)
{
	ClickUser * self = NULL;
	ClickDB* real_db = NULL;
	gchar* real_name = NULL;
	ClickDB* _tmp6_;
	const gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
	if (db != NULL) {
		ClickDB* _tmp0_;
		_tmp0_ = _g_object_ref0 (db);
		_g_object_unref0 (real_db);
		real_db = _tmp0_;
	} else {
		ClickDB* _tmp1_;
		ClickDB* _tmp2_;
		_tmp1_ = click_db_new ();
		_g_object_unref0 (real_db);
		real_db = _tmp1_;
		_tmp2_ = real_db;
		click_db_read (_tmp2_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (real_name);
				_g_object_unref0 (real_db);
				_g_object_unref0 (self);
				return NULL;
			} else {
				_g_free0 (real_name);
				_g_object_unref0 (real_db);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	}
	if (name != NULL) {
		gchar* _tmp3_;
		_tmp3_ = g_strdup (name);
		_g_free0 (real_name);
		real_name = _tmp3_;
	} else {
		const gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp4_ = g_get_user_name ();
		_tmp5_ = g_strdup (_tmp4_);
		_g_free0 (real_name);
		real_name = _tmp5_;
	}
	_tmp6_ = real_db;
	_tmp7_ = real_name;
	self = (ClickUser*) g_object_new (object_type, "db", _tmp6_, "name", _tmp7_, NULL);
	_g_object_unref0 (self->priv->users);
	self->priv->users = NULL;
	_g_object_unref0 (self->priv->user_pw);
	self->priv->user_pw = NULL;
	self->priv->dropped_privileges_count = 0;
	_g_free0 (self->priv->old_umask);
	self->priv->old_umask = NULL;
	_g_free0 (real_name);
	_g_object_unref0 (real_db);
	return self;
}

static ClickUser*
click_user_new (ClickDB* db,
                const gchar* name,
                GError** error)
{
	return click_user_construct (CLICK_TYPE_USER, db, name, error);
}

ClickUser*
click_user_construct_for_user (GType object_type,
                               ClickDB* db,
                               const gchar* name,
                               GError** error)
{
	ClickUser * self = NULL;
	GError* _inner_error0_ = NULL;
	self = (ClickUser*) click_user_construct (object_type, db, name, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	return self;
}

ClickUser*
click_user_new_for_user (ClickDB* db,
                         const gchar* name,
                         GError** error)
{
	return click_user_construct_for_user (CLICK_TYPE_USER, db, name, error);
}

ClickUser*
click_user_construct_for_all_users (GType object_type,
                                    ClickDB* db,
                                    GError** error)
{
	ClickUser * self = NULL;
	GError* _inner_error0_ = NULL;
	self = (ClickUser*) click_user_construct (object_type, db, CLICK_ALL_USERS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	return self;
}

ClickUser*
click_user_new_for_all_users (ClickDB* db,
                              GError** error)
{
	return click_user_construct_for_all_users (CLICK_TYPE_USER, db, error);
}

ClickUser*
click_user_construct_for_gc_in_use (GType object_type,
                                    ClickDB* db,
                                    GError** error)
{
	ClickUser * self = NULL;
	GError* _inner_error0_ = NULL;
	self = (ClickUser*) click_user_construct (object_type, db, CLICK_GC_IN_USE_USER, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	return self;
}

ClickUser*
click_user_new_for_gc_in_use (ClickDB* db,
                              GError** error)
{
	return click_user_construct_for_gc_in_use (CLICK_TYPE_USER, db, error);
}

/**
 * get_user_pw:
 *
 * Returns: The password file entry for this user.
 */
static ClickCachedPasswd*
click_user_get_user_pw (ClickUser* self,
                        GError** error)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	ClickCachedPasswd* _tmp2_;
	ClickCachedPasswd* _tmp12_;
	ClickCachedPasswd* _tmp13_;
	GError* _inner_error0_ = NULL;
	ClickCachedPasswd* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = click_user_get_is_pseudo_user (self);
	_tmp1_ = _tmp0_;
	_vala_assert (!_tmp1_, "! is_pseudo_user");
	_tmp2_ = self->priv->user_pw;
	if (_tmp2_ == NULL) {
		struct passwd* pw = NULL;
		const gchar* _tmp3_;
		struct passwd* _tmp4_;
		struct passwd* _tmp5_;
		struct passwd* _tmp9_;
		struct passwd* _tmp10_;
		ClickCachedPasswd* _tmp11_;
		errno = 0;
		_tmp3_ = self->priv->_name;
		_tmp4_ = getpwnam (_tmp3_);
		pw = _tmp4_;
		_tmp5_ = pw;
		if (_tmp5_ == NULL) {
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			GError* _tmp8_;
			_tmp6_ = self->priv->_name;
			_tmp7_ = g_strerror (errno);
			_tmp8_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_GETPWNAM, "Cannot get password file entry for " "%s: %s", _tmp6_, _tmp7_);
			_inner_error0_ = _tmp8_;
			if (_inner_error0_->domain == CLICK_USER_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp9_ = pw;
		_tmp10_ = pw;
		_tmp11_ = click_cached_passwd_new (_tmp9_->pw_uid, _tmp10_->pw_gid);
		_g_object_unref0 (self->priv->user_pw);
		self->priv->user_pw = _tmp11_;
	}
	_tmp12_ = self->priv->user_pw;
	_tmp13_ = _g_object_ref0 (_tmp12_);
	result = _tmp13_;
	return result;
}

/**
 * get_overlay_db:
 *
 * Returns: The path to the overlay database for this user, i.e. the
 * path where new packages will be installed.
 */
gchar*
click_user_get_overlay_db (ClickUser* self)
{
	ClickDB* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_db;
	_tmp1_ = click_db_get_overlay (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->_name;
	_tmp4_ = click_db_for_user (_tmp2_, _tmp3_);
	result = _tmp4_;
	return result;
}

static void
click_user_ensure_db (ClickUser* self,
                      GError** error)
{
	ClickUsers* _tmp0_;
	ClickUsers* _tmp3_;
	gchar* path = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->users;
	if (_tmp0_ == NULL) {
		ClickDB* _tmp1_;
		ClickUsers* _tmp2_;
		_tmp1_ = self->priv->_db;
		_tmp2_ = click_users_new (_tmp1_);
		_g_object_unref0 (self->priv->users);
		self->priv->users = _tmp2_;
	}
	_tmp3_ = self->priv->users;
	click_users_ensure_db (_tmp3_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == CLICK_USER_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp4_ = click_user_get_overlay_db (self);
	path = _tmp4_;
	_tmp5_ = path;
	if (!click_exists (_tmp5_)) {
		const gchar* _tmp6_;
		gboolean _tmp7_ = FALSE;
		_tmp6_ = path;
		click_try_create (_tmp6_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == CLICK_USER_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (path);
				return;
			} else {
				_g_free0 (path);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		if (geteuid () == ((uid_t) 0)) {
			gboolean _tmp8_;
			gboolean _tmp9_;
			_tmp8_ = click_user_get_is_pseudo_user (self);
			_tmp9_ = _tmp8_;
			_tmp7_ = !_tmp9_;
		} else {
			_tmp7_ = FALSE;
		}
		if (_tmp7_) {
			ClickCachedPasswd* _tmp10_ = NULL;
			ClickCachedPasswd* _tmp11_;
			const gchar* _tmp12_;
			_tmp11_ = click_user_get_user_pw (self, &_inner_error0_);
			_tmp10_ = _tmp11_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == CLICK_USER_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_g_free0 (path);
					return;
				} else {
					_g_free0 (path);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_tmp12_ = path;
			click_try_chown (_tmp12_, _tmp10_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == CLICK_USER_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_g_object_unref0 (_tmp10_);
					_g_free0 (path);
					return;
				} else {
					_g_object_unref0 (_tmp10_);
					_g_free0 (path);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_g_object_unref0 (_tmp10_);
		}
	}
	_g_free0 (path);
}

static void
click_user_priv_drop_failure (ClickUser* self,
                              const gchar* name,
                              GError** error)
{
	const gchar* _tmp0_;
	GError* _tmp1_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = g_strerror (errno);
	_tmp1_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_DROP_PRIVS, "Cannot drop privileges (%s): %s", name, _tmp0_);
	_inner_error0_ = _tmp1_;
	if (_inner_error0_->domain == CLICK_USER_ERROR) {
		g_propagate_error (error, _inner_error0_);
		return;
	} else {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static mode_t*
_mode_t_dup (mode_t* self)
{
	mode_t* dup;
	dup = g_new0 (mode_t, 1);
	memcpy (dup, self, sizeof (mode_t));
	return dup;
}

static gpointer
__mode_t_dup0 (gpointer self)
{
	return self ? _mode_t_dup (self) : NULL;
}

void
click_user_drop_privileges (ClickUser* self,
                            GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint _tmp9_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	if (self->priv->dropped_privileges_count == 0) {
		_tmp1_ = getuid () == ((uid_t) 0);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = click_user_get_is_pseudo_user (self);
		_tmp3_ = _tmp2_;
		_tmp0_ = !_tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		ClickCachedPasswd* pw = NULL;
		ClickCachedPasswd* _tmp4_;
		ClickCachedPasswd* _tmp5_;
		ClickCachedPasswd* _tmp6_;
		mode_t _tmp7_;
		mode_t* _tmp8_;
		_tmp4_ = click_user_get_user_pw (self, &_inner_error0_);
		pw = _tmp4_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == CLICK_USER_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp5_ = pw;
		if (setegid (_tmp5_->gid) < 0) {
			click_user_priv_drop_failure (self, "setegid", &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == CLICK_USER_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_g_object_unref0 (pw);
					return;
				} else {
					_g_object_unref0 (pw);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
		}
		_tmp6_ = pw;
		if (seteuid (_tmp6_->uid) < 0) {
			click_user_priv_drop_failure (self, "seteuid", &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == CLICK_USER_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_g_object_unref0 (pw);
					return;
				} else {
					_g_object_unref0 (pw);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
		}
		_tmp7_ = umask ((mode_t) (click_get_umask () | S_IWOTH));
		_tmp8_ = __mode_t_dup0 (&_tmp7_);
		_g_free0 (self->priv->old_umask);
		self->priv->old_umask = _tmp8_;
		_g_object_unref0 (pw);
	}
	self->priv->dropped_privileges_count = self->priv->dropped_privileges_count + 1;
	_tmp9_ = self->priv->dropped_privileges_count;
}

static void
click_user_priv_regain_failure (ClickUser* self,
                                const gchar* name)
{
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = g_strerror (errno);
	g_error ("user.vala:396: Cannot regain privileges (%s): %s", name, _tmp0_);
}

void
click_user_regain_privileges (ClickUser* self)
{
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	g_return_if_fail (self != NULL);
	self->priv->dropped_privileges_count = self->priv->dropped_privileges_count - 1;
	_tmp0_ = self->priv->dropped_privileges_count;
	if (self->priv->dropped_privileges_count == 0) {
		_tmp2_ = getuid () == ((uid_t) 0);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp3_ = click_user_get_is_pseudo_user (self);
		_tmp4_ = _tmp3_;
		_tmp1_ = !_tmp4_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		mode_t* _tmp5_;
		_tmp5_ = self->priv->old_umask;
		if (_tmp5_ != NULL) {
			mode_t* _tmp6_;
			_tmp6_ = self->priv->old_umask;
			umask (*_tmp6_);
		}
		if (seteuid ((uid_t) 0) < 0) {
			click_user_priv_regain_failure (self, "seteuid");
		}
		if (setegid ((gid_t) 0) < 0) {
			click_user_priv_regain_failure (self, "setegid");
		}
	}
}

static gboolean
click_user_is_valid_link (ClickUser* self,
                          const gchar* path)
{
	gboolean _tmp3_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	if (!click_is_symlink (path)) {
		result = FALSE;
		return result;
	}
	{
		gchar* target = NULL;
		gchar* _tmp0_;
		const gchar* _tmp2_;
		_tmp0_ = g_file_read_link (path, &_inner_error0_);
		target = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp1_ = FALSE;
			if (_inner_error0_->domain == G_FILE_ERROR) {
				goto __catch0_g_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp1_;
		}
		_tmp2_ = target;
		result = !g_str_has_prefix (_tmp2_, "@");
		_g_free0 (target);
		return result;
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		g_clear_error (&_inner_error0_);
		result = FALSE;
		return result;
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return _tmp3_;
}

static GList*
click_user_get_package_names_dropped (ClickUser* self,
                                      GError** error)
{
	GList* entries = NULL;
	GeeHashSet* hidden = NULL;
	GeeHashSet* _tmp0_;
	GError* _inner_error0_ = NULL;
	GList* result;
	g_return_val_if_fail (self != NULL, NULL);
	entries = NULL;
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
	hidden = _tmp0_;
	{
		gint i = 0;
		ClickDB* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		_tmp1_ = self->priv->_db;
		_tmp2_ = click_db_get_size (_tmp1_);
		_tmp3_ = _tmp2_;
		i = _tmp3_ - 1;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				ClickSingleDB* _tmp6_ = NULL;
				ClickDB* _tmp7_;
				ClickSingleDB* _tmp8_;
				gchar* user_db = NULL;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				ClickDir* _tmp13_ = NULL;
				const gchar* _tmp14_;
				ClickDir* _tmp15_;
				const gchar* _tmp38_;
				if (!_tmp4_) {
					gint _tmp5_;
					i = i - 1;
					_tmp5_ = i;
				}
				_tmp4_ = FALSE;
				if (!(i >= 0)) {
					break;
				}
				_tmp7_ = self->priv->_db;
				_tmp8_ = click_db_get (_tmp7_, i, &_inner_error0_);
				_tmp6_ = _tmp8_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_object_unref0 (hidden);
					(entries == NULL) ? NULL : (entries = (_g_list_free__g_free0_ (entries), NULL));
					return NULL;
				}
				_tmp9_ = click_single_db_get_root (_tmp6_);
				_tmp10_ = _tmp9_;
				_tmp11_ = self->priv->_name;
				_tmp12_ = click_db_for_user (_tmp10_, _tmp11_);
				user_db = _tmp12_;
				_tmp14_ = user_db;
				_tmp15_ = click_dir_open (_tmp14_, (guint) 0, &_inner_error0_);
				_tmp13_ = _tmp15_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_free0 (user_db);
					_g_object_unref0 (_tmp6_);
					_g_object_unref0 (hidden);
					(entries == NULL) ? NULL : (entries = (_g_list_free__g_free0_ (entries), NULL));
					return NULL;
				}
				{
					ClickDirIterator* _entry_it = NULL;
					ClickDirIterator* _tmp16_;
					const gchar* entry = NULL;
					_tmp16_ = click_dir_iterator (_tmp13_);
					_entry_it = _tmp16_;
					while (TRUE) {
						ClickDirIterator* _tmp17_;
						const gchar* _tmp18_;
						const gchar* _tmp19_;
						gboolean _tmp20_ = FALSE;
						GList* _tmp21_;
						const gchar* _tmp22_;
						GCompareFunc _tmp23_;
						GList* _tmp24_;
						gchar* path = NULL;
						const gchar* _tmp27_;
						const gchar* _tmp28_;
						gchar* _tmp29_;
						const gchar* _tmp30_;
						_tmp17_ = _entry_it;
						_tmp18_ = click_dir_iterator_next_value (_tmp17_);
						entry = _tmp18_;
						_tmp19_ = entry;
						if (!(_tmp19_ != NULL)) {
							break;
						}
						_tmp21_ = entries;
						_tmp22_ = entry;
						_tmp23_ = ((GCompareFunc) g_strcmp0);
						_tmp24_ = g_list_find_custom (_tmp21_, _tmp22_, _tmp23_);
						if (_tmp24_ != NULL) {
							_tmp20_ = TRUE;
						} else {
							GeeHashSet* _tmp25_;
							const gchar* _tmp26_;
							_tmp25_ = hidden;
							_tmp26_ = entry;
							_tmp20_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp25_, _tmp26_);
						}
						if (_tmp20_) {
							continue;
						}
						_tmp27_ = user_db;
						_tmp28_ = entry;
						_tmp29_ = g_build_filename (_tmp27_, _tmp28_, NULL);
						path = _tmp29_;
						_tmp30_ = path;
						if (click_user_is_valid_link (self, _tmp30_)) {
							const gchar* _tmp31_;
							gchar* _tmp32_;
							_tmp31_ = entry;
							_tmp32_ = g_strdup (_tmp31_);
							entries = g_list_prepend (entries, _tmp32_);
						} else {
							const gchar* _tmp33_;
							_tmp33_ = path;
							if (click_is_symlink (_tmp33_)) {
								GeeHashSet* _tmp34_;
								const gchar* _tmp35_;
								gchar* _tmp36_;
								gchar* _tmp37_;
								_tmp34_ = hidden;
								_tmp35_ = entry;
								_tmp36_ = g_strdup (_tmp35_);
								_tmp37_ = _tmp36_;
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp34_, _tmp37_);
								_g_free0 (_tmp37_);
							}
						}
						_g_free0 (path);
					}
					_g_object_unref0 (_entry_it);
				}
				_tmp38_ = self->priv->_name;
				if (g_strcmp0 (_tmp38_, CLICK_ALL_USERS) != 0) {
					ClickSingleDB* _tmp39_ = NULL;
					ClickDB* _tmp40_;
					ClickSingleDB* _tmp41_;
					gchar* all_users_db = NULL;
					const gchar* _tmp42_;
					const gchar* _tmp43_;
					gchar* _tmp44_;
					ClickDir* _tmp45_ = NULL;
					const gchar* _tmp46_;
					ClickDir* _tmp47_;
					_tmp40_ = self->priv->_db;
					_tmp41_ = click_db_get (_tmp40_, i, &_inner_error0_);
					_tmp39_ = _tmp41_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						g_propagate_error (error, _inner_error0_);
						_g_object_unref0 (_tmp13_);
						_g_free0 (user_db);
						_g_object_unref0 (_tmp6_);
						_g_object_unref0 (hidden);
						(entries == NULL) ? NULL : (entries = (_g_list_free__g_free0_ (entries), NULL));
						return NULL;
					}
					_tmp42_ = click_single_db_get_root (_tmp39_);
					_tmp43_ = _tmp42_;
					_tmp44_ = click_db_for_user (_tmp43_, CLICK_ALL_USERS);
					all_users_db = _tmp44_;
					_tmp46_ = all_users_db;
					_tmp47_ = click_dir_open (_tmp46_, (guint) 0, &_inner_error0_);
					_tmp45_ = _tmp47_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						g_propagate_error (error, _inner_error0_);
						_g_free0 (all_users_db);
						_g_object_unref0 (_tmp39_);
						_g_object_unref0 (_tmp13_);
						_g_free0 (user_db);
						_g_object_unref0 (_tmp6_);
						_g_object_unref0 (hidden);
						(entries == NULL) ? NULL : (entries = (_g_list_free__g_free0_ (entries), NULL));
						return NULL;
					}
					{
						ClickDirIterator* _entry_it = NULL;
						ClickDirIterator* _tmp48_;
						const gchar* entry = NULL;
						_tmp48_ = click_dir_iterator (_tmp45_);
						_entry_it = _tmp48_;
						while (TRUE) {
							ClickDirIterator* _tmp49_;
							const gchar* _tmp50_;
							const gchar* _tmp51_;
							gboolean _tmp52_ = FALSE;
							GList* _tmp53_;
							const gchar* _tmp54_;
							GCompareFunc _tmp55_;
							GList* _tmp56_;
							gchar* path = NULL;
							const gchar* _tmp59_;
							const gchar* _tmp60_;
							gchar* _tmp61_;
							const gchar* _tmp62_;
							_tmp49_ = _entry_it;
							_tmp50_ = click_dir_iterator_next_value (_tmp49_);
							entry = _tmp50_;
							_tmp51_ = entry;
							if (!(_tmp51_ != NULL)) {
								break;
							}
							_tmp53_ = entries;
							_tmp54_ = entry;
							_tmp55_ = ((GCompareFunc) g_strcmp0);
							_tmp56_ = g_list_find_custom (_tmp53_, _tmp54_, _tmp55_);
							if (_tmp56_ != NULL) {
								_tmp52_ = TRUE;
							} else {
								GeeHashSet* _tmp57_;
								const gchar* _tmp58_;
								_tmp57_ = hidden;
								_tmp58_ = entry;
								_tmp52_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp57_, _tmp58_);
							}
							if (_tmp52_) {
								continue;
							}
							_tmp59_ = all_users_db;
							_tmp60_ = entry;
							_tmp61_ = g_build_filename (_tmp59_, _tmp60_, NULL);
							path = _tmp61_;
							_tmp62_ = path;
							if (click_user_is_valid_link (self, _tmp62_)) {
								const gchar* _tmp63_;
								gchar* _tmp64_;
								_tmp63_ = entry;
								_tmp64_ = g_strdup (_tmp63_);
								entries = g_list_prepend (entries, _tmp64_);
							} else {
								const gchar* _tmp65_;
								_tmp65_ = path;
								if (click_is_symlink (_tmp65_)) {
									GeeHashSet* _tmp66_;
									const gchar* _tmp67_;
									gchar* _tmp68_;
									gchar* _tmp69_;
									_tmp66_ = hidden;
									_tmp67_ = entry;
									_tmp68_ = g_strdup (_tmp67_);
									_tmp69_ = _tmp68_;
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp66_, _tmp69_);
									_g_free0 (_tmp69_);
								}
							}
							_g_free0 (path);
						}
						_g_object_unref0 (_entry_it);
					}
					_g_object_unref0 (_tmp45_);
					_g_free0 (all_users_db);
					_g_object_unref0 (_tmp39_);
				}
				_g_object_unref0 (_tmp13_);
				_g_free0 (user_db);
				_g_object_unref0 (_tmp6_);
			}
		}
	}
	entries = g_list_reverse (entries);
	result = entries;
	_g_object_unref0 (hidden);
	return result;
}

/**
 * get_package_names:
 *
 * Returns: (transfer full): A list of package names installed for
 * this user.
 */
GList*
click_user_get_package_names (ClickUser* self,
                              GError** error)
{
	GError* _inner_error0_ = NULL;
	GList* result;
	g_return_val_if_fail (self != NULL, NULL);
	click_user_drop_privileges (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	{
		GList* _tmp0_ = NULL;
		GList* _tmp1_;
		GList* _tmp2_;
		_tmp1_ = click_user_get_package_names_dropped (self, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __finally0;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		result = _tmp2_;
		(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_list_free__g_free0_ (_tmp0_), NULL));
		{
			GError* _inner_error0_ = NULL;
			click_user_regain_privileges (self);
		}
		return result;
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
		click_user_regain_privileges (self);
	}
	g_propagate_error (error, _inner_error0_);
	return NULL;
}

/**
 * has_package_name:
 * @package: A package name.
 *
 * Returns: True if this user has a version of @package registered,
 * otherwise false.
 */
gboolean
click_user_has_package_name (ClickUser* self,
                             const gchar* package)
{
	gboolean _tmp3_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (package != NULL, FALSE);
	{
		gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = click_user_get_version (self, package, &_inner_error0_);
		_tmp1_ = _tmp0_;
		_g_free0 (_tmp1_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp2_ = FALSE;
			if (_inner_error0_->domain == CLICK_USER_ERROR) {
				goto __catch0_click_user_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp2_;
		}
		result = TRUE;
		return result;
	}
	goto __finally0;
	__catch0_click_user_error:
	{
		g_clear_error (&_inner_error0_);
		result = FALSE;
		return result;
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return _tmp3_;
}

/**
 * get_version:
 * @package: A package name.
 *
 * Returns: The version of @package registered for this user.
 */
gchar*
click_user_get_version (ClickUser* self,
                        const gchar* package,
                        GError** error)
{
	const gchar* _tmp37_;
	GError* _tmp38_;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (package != NULL, NULL);
	{
		gint i = 0;
		ClickDB* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		_tmp0_ = self->priv->_db;
		_tmp1_ = click_db_get_size (_tmp0_);
		_tmp2_ = _tmp1_;
		i = _tmp2_ - 1;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				ClickSingleDB* _tmp5_ = NULL;
				ClickDB* _tmp6_;
				ClickSingleDB* _tmp7_;
				gchar* user_db = NULL;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* path = NULL;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				ClickSingleDB* _tmp22_ = NULL;
				ClickDB* _tmp23_;
				ClickSingleDB* _tmp24_;
				gchar* all_users_db = NULL;
				const gchar* _tmp25_;
				const gchar* _tmp26_;
				gchar* _tmp27_;
				const gchar* _tmp28_;
				gchar* _tmp29_;
				const gchar* _tmp30_;
				if (!_tmp3_) {
					gint _tmp4_;
					i = i - 1;
					_tmp4_ = i;
				}
				_tmp3_ = FALSE;
				if (!(i >= 0)) {
					break;
				}
				_tmp6_ = self->priv->_db;
				_tmp7_ = click_db_get (_tmp6_, i, &_inner_error0_);
				_tmp5_ = _tmp7_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == CLICK_USER_ERROR) {
						g_propagate_error (error, _inner_error0_);
						return NULL;
					} else {
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp8_ = click_single_db_get_root (_tmp5_);
				_tmp9_ = _tmp8_;
				_tmp10_ = self->priv->_name;
				_tmp11_ = click_db_for_user (_tmp9_, _tmp10_);
				user_db = _tmp11_;
				_tmp12_ = user_db;
				_tmp13_ = g_build_filename (_tmp12_, package, NULL);
				path = _tmp13_;
				click_user_drop_privileges (self, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == CLICK_USER_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_g_free0 (path);
						_g_free0 (user_db);
						_g_object_unref0 (_tmp5_);
						return NULL;
					} else {
						_g_free0 (path);
						_g_free0 (user_db);
						_g_object_unref0 (_tmp5_);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				{
					const gchar* _tmp14_;
					_tmp14_ = path;
					if (click_user_is_valid_link (self, _tmp14_)) {
						{
							gchar* target = NULL;
							const gchar* _tmp15_;
							gchar* _tmp16_;
							const gchar* _tmp17_;
							gchar* _tmp18_;
							_tmp15_ = path;
							_tmp16_ = g_file_read_link (_tmp15_, &_inner_error0_);
							target = _tmp16_;
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								if (_inner_error0_->domain == G_FILE_ERROR) {
									goto __catch1_g_file_error;
								}
								{
									GError* _inner_error0_ = NULL;
									click_user_regain_privileges (self);
								}
								_g_free0 (path);
								_g_free0 (user_db);
								_g_object_unref0 (_tmp5_);
								g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
								g_clear_error (&_inner_error0_);
								return NULL;
							}
							_tmp17_ = target;
							_tmp18_ = g_path_get_basename (_tmp17_);
							result = _tmp18_;
							_g_free0 (target);
							{
								GError* _inner_error0_ = NULL;
								click_user_regain_privileges (self);
							}
							_g_free0 (path);
							_g_free0 (user_db);
							_g_object_unref0 (_tmp5_);
							return result;
						}
						goto __finally1;
						__catch1_g_file_error:
						{
							g_clear_error (&_inner_error0_);
						}
						__finally1:
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							_g_free0 (path);
							_g_free0 (user_db);
							_g_object_unref0 (_tmp5_);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return NULL;
						}
					} else {
						const gchar* _tmp19_;
						_tmp19_ = path;
						if (click_is_symlink (_tmp19_)) {
							const gchar* _tmp20_;
							GError* _tmp21_;
							_tmp20_ = self->priv->_name;
							_tmp21_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_HIDDEN_PACKAGE, "%s is hidden for user %s", package, _tmp20_);
							_inner_error0_ = _tmp21_;
							goto __finally0;
						}
					}
				}
				__finally0:
				{
					GError* _inner_error1_ = NULL;
					click_user_regain_privileges (self);
				}
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == CLICK_USER_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_g_free0 (path);
						_g_free0 (user_db);
						_g_object_unref0 (_tmp5_);
						return NULL;
					} else {
						_g_free0 (path);
						_g_free0 (user_db);
						_g_object_unref0 (_tmp5_);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp23_ = self->priv->_db;
				_tmp24_ = click_db_get (_tmp23_, i, &_inner_error0_);
				_tmp22_ = _tmp24_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == CLICK_USER_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_g_free0 (path);
						_g_free0 (user_db);
						_g_object_unref0 (_tmp5_);
						return NULL;
					} else {
						_g_free0 (path);
						_g_free0 (user_db);
						_g_object_unref0 (_tmp5_);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp25_ = click_single_db_get_root (_tmp22_);
				_tmp26_ = _tmp25_;
				_tmp27_ = click_db_for_user (_tmp26_, CLICK_ALL_USERS);
				all_users_db = _tmp27_;
				_tmp28_ = all_users_db;
				_tmp29_ = g_build_filename (_tmp28_, package, NULL);
				_g_free0 (path);
				path = _tmp29_;
				_tmp30_ = path;
				if (click_user_is_valid_link (self, _tmp30_)) {
					{
						gchar* target = NULL;
						const gchar* _tmp31_;
						gchar* _tmp32_;
						const gchar* _tmp33_;
						gchar* _tmp34_;
						_tmp31_ = path;
						_tmp32_ = g_file_read_link (_tmp31_, &_inner_error0_);
						target = _tmp32_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							if (_inner_error0_->domain == G_FILE_ERROR) {
								goto __catch2_g_file_error;
							}
							_g_free0 (all_users_db);
							_g_object_unref0 (_tmp22_);
							_g_free0 (path);
							_g_free0 (user_db);
							_g_object_unref0 (_tmp5_);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return NULL;
						}
						_tmp33_ = target;
						_tmp34_ = g_path_get_basename (_tmp33_);
						result = _tmp34_;
						_g_free0 (target);
						_g_free0 (all_users_db);
						_g_object_unref0 (_tmp22_);
						_g_free0 (path);
						_g_free0 (user_db);
						_g_object_unref0 (_tmp5_);
						return result;
					}
					goto __finally2;
					__catch2_g_file_error:
					{
						g_clear_error (&_inner_error0_);
					}
					__finally2:
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == CLICK_USER_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_g_free0 (all_users_db);
							_g_object_unref0 (_tmp22_);
							_g_free0 (path);
							_g_free0 (user_db);
							_g_object_unref0 (_tmp5_);
							return NULL;
						} else {
							_g_free0 (all_users_db);
							_g_object_unref0 (_tmp22_);
							_g_free0 (path);
							_g_free0 (user_db);
							_g_object_unref0 (_tmp5_);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return NULL;
						}
					}
				} else {
					const gchar* _tmp35_;
					_tmp35_ = path;
					if (click_is_symlink (_tmp35_)) {
						GError* _tmp36_;
						_tmp36_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_HIDDEN_PACKAGE, "%s is hidden for all users", package);
						_inner_error0_ = _tmp36_;
						if (_inner_error0_->domain == CLICK_USER_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_g_free0 (all_users_db);
							_g_object_unref0 (_tmp22_);
							_g_free0 (path);
							_g_free0 (user_db);
							_g_object_unref0 (_tmp5_);
							return NULL;
						} else {
							_g_free0 (all_users_db);
							_g_object_unref0 (_tmp22_);
							_g_free0 (path);
							_g_free0 (user_db);
							_g_object_unref0 (_tmp5_);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return NULL;
						}
					}
				}
				_g_free0 (all_users_db);
				_g_object_unref0 (_tmp22_);
				_g_free0 (path);
				_g_free0 (user_db);
				_g_object_unref0 (_tmp5_);
			}
		}
	}
	_tmp37_ = self->priv->_name;
	_tmp38_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_NO_SUCH_PACKAGE, "%s does not exist in any database for user %s", package, _tmp37_);
	_inner_error0_ = _tmp38_;
	if (_inner_error0_->domain == CLICK_USER_ERROR) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	} else {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

/**
 * raw_set_version:
 * @package: A package name.
 * @version: A version string.
 *
 * Set the version of @package to @version, without running any
 * hooks.  Must be run with dropped privileges.
 */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

void
click_user_raw_set_version (ClickUser* self,
                            const gchar* package,
                            const gchar* version,
                            GError** error)
{
	gchar* user_db = NULL;
	gchar* _tmp0_;
	gchar* path = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* new_path = NULL;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* target = NULL;
	ClickDB* _tmp9_;
	gchar* _tmp10_;
	gboolean done = FALSE;
	const gchar* _tmp11_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (package != NULL);
	g_return_if_fail (version != NULL);
	_vala_assert (self->priv->dropped_privileges_count > 0, "dropped_privileges_count > 0");
	_tmp0_ = click_user_get_overlay_db (self);
	user_db = _tmp0_;
	_tmp1_ = user_db;
	_tmp2_ = g_build_filename (_tmp1_, package, NULL);
	path = _tmp2_;
	_tmp3_ = user_db;
	_tmp4_ = string_to_string (package);
	_tmp5_ = g_strconcat (".", _tmp4_, ".new", NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_build_filename (_tmp3_, _tmp6_, NULL);
	_tmp8_ = _tmp7_;
	_g_free0 (_tmp6_);
	new_path = _tmp8_;
	_tmp9_ = self->priv->_db;
	_tmp10_ = click_db_get_path (_tmp9_, package, version, &_inner_error0_);
	target = _tmp10_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (new_path);
		_g_free0 (path);
		_g_free0 (user_db);
		return;
	}
	done = FALSE;
	_tmp11_ = path;
	if (click_user_is_valid_link (self, _tmp11_)) {
		const gchar* _tmp12_;
		_tmp12_ = path;
		click_unlink_force (_tmp12_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (target);
			_g_free0 (new_path);
			_g_free0 (path);
			_g_free0 (user_db);
			return;
		}
		{
			gchar* _tmp13_ = NULL;
			gchar* _tmp14_;
			_tmp14_ = click_user_get_version (self, package, &_inner_error0_);
			_tmp13_ = _tmp14_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == CLICK_USER_ERROR) {
					goto __catch0_click_user_error;
				}
				_g_free0 (target);
				_g_free0 (new_path);
				_g_free0 (path);
				_g_free0 (user_db);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			if (g_strcmp0 (_tmp13_, version) == 0) {
				done = TRUE;
			}
			_g_free0 (_tmp13_);
		}
		goto __finally0;
		__catch0_click_user_error:
		{
			g_clear_error (&_inner_error0_);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (target);
			_g_free0 (new_path);
			_g_free0 (path);
			_g_free0 (user_db);
			return;
		}
	}
	if (done) {
		_g_free0 (target);
		_g_free0 (new_path);
		_g_free0 (path);
		_g_free0 (user_db);
		return;
	}
	_tmp15_ = target;
	_tmp16_ = new_path;
	click_symlink_force (_tmp15_, _tmp16_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (target);
		_g_free0 (new_path);
		_g_free0 (path);
		_g_free0 (user_db);
		return;
	}
	_tmp17_ = new_path;
	_tmp18_ = path;
	if (g_rename (_tmp17_, _tmp18_) < 0) {
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		GError* _tmp22_;
		_tmp19_ = new_path;
		_tmp20_ = path;
		_tmp21_ = g_strerror (errno);
		_tmp22_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_RENAME, "rename %s -> %s failed: %s", _tmp19_, _tmp20_, _tmp21_);
		_inner_error0_ = _tmp22_;
		g_propagate_error (error, _inner_error0_);
		_g_free0 (target);
		_g_free0 (new_path);
		_g_free0 (path);
		_g_free0 (user_db);
		return;
	}
	_g_free0 (target);
	_g_free0 (new_path);
	_g_free0 (path);
	_g_free0 (user_db);
}

/**
 * set_version:
 * @package: A package name.
 * @version: A version string.
 *
 * Register version @version of @package for this user.
 */
void
click_user_set_version (ClickUser* self,
                        const gchar* package,
                        const gchar* version,
                        GError** error)
{
	gchar* old_version = NULL;
	gboolean _tmp3_;
	gboolean _tmp4_;
	const gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (package != NULL);
	g_return_if_fail (version != NULL);
	click_user_ensure_db (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
	old_version = NULL;
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = click_user_get_version (self, package, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == CLICK_USER_ERROR) {
				goto __catch0_click_user_error;
			}
			_g_free0 (old_version);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_free0 (old_version);
		old_version = _tmp2_;
		_g_free0 (_tmp0_);
	}
	goto __finally0;
	__catch0_click_user_error:
	{
		g_clear_error (&_inner_error0_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (old_version);
		return;
	}
	click_user_drop_privileges (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (old_version);
		return;
	}
	{
		click_user_raw_set_version (self, package, version, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __finally1;
		}
	}
	__finally1:
	{
		GError* _inner_error1_ = NULL;
		click_user_regain_privileges (self);
	}
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (old_version);
		return;
	}
	_tmp3_ = click_user_get_is_pseudo_user (self);
	_tmp4_ = _tmp3_;
	if (!_tmp4_) {
		ClickDB* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		_tmp5_ = self->priv->_db;
		_tmp6_ = old_version;
		_tmp7_ = self->priv->_name;
		click_package_install_hooks (_tmp5_, package, _tmp6_, version, _tmp7_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (old_version);
			return;
		}
	}
	_tmp8_ = self->priv->_name;
	if (g_strcmp0 (_tmp8_, CLICK_ALL_USERS) == 0) {
		const gchar* _tmp9_;
		_tmp9_ = old_version;
		click_user_run_user_install_hooks_for_all_logged_in_users (self, package, _tmp9_, version, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (old_version);
			return;
		}
	}
	_g_free0 (old_version);
}

static void
_vala_array_add12 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gchar**
click_user_get_logged_in_users (ClickUser* self,
                                gint* result_length1)
{
	gchar** logged_in_users = NULL;
	gchar** _tmp0_;
	gint logged_in_users_length1;
	gint _logged_in_users_size_;
	gchar** _tmp26_;
	gint _tmp26__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	logged_in_users = _tmp0_;
	logged_in_users_length1 = 0;
	_logged_in_users_size_ = logged_in_users_length1;
	{
		ClickLogindManager* logind = NULL;
		ClickLogindManager* _tmp1_;
		ClickLogindUser* users = NULL;
		ClickLogindManager* _tmp2_;
		gint _tmp3_ = 0;
		ClickLogindUser* _tmp4_;
		gint users_length1;
		gint _users_size_;
		ClickLogindUser* _tmp5_;
		gint _tmp5__length1;
		_tmp1_ = (ClickLogindManager*) g_initable_new (CLICK_TYPE_LOGIND_MANAGER_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.freedesktop.login1", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", "/org/freedesktop/login1", "g-interface-name", "org.freedesktop.login1.Manager", NULL);
		logind = (ClickLogindManager*) _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = logind;
		_tmp4_ = click_logind_manager_ListUsers (_tmp2_, &_tmp3_, &_inner_error0_);
		users = _tmp4_;
		users_length1 = _tmp3_;
		_users_size_ = users_length1;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (logind);
			goto __catch0_g_error;
		}
		_tmp5_ = users;
		_tmp5__length1 = users_length1;
		{
			ClickLogindUser* user_collection = NULL;
			gint user_collection_length1 = 0;
			gint _user_collection_size_ = 0;
			gint user_it = 0;
			user_collection = _tmp5_;
			user_collection_length1 = _tmp5__length1;
			for (user_it = 0; user_it < user_collection_length1; user_it = user_it + 1) {
				ClickLogindUser _tmp6_;
				ClickLogindUser _tmp7_ = {0};
				ClickLogindUser user = {0};
				_tmp6_ = user_collection[user_it];
				click_logind_user_copy (&_tmp6_, &_tmp7_);
				user = _tmp7_;
				{
					ClickASUser* asUser = NULL;
					ClickLogindUser _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					ClickASUser* _tmp13_;
					ClickASUser* _tmp14_;
					ClickASUser* _tmp15_;
					gboolean _tmp16_;
					gboolean _tmp17_;
					_tmp8_ = user;
					_tmp9_ = g_strdup_printf ("%u", _tmp8_.uid);
					_tmp10_ = _tmp9_;
					_tmp11_ = g_strconcat ("/org/freedesktop/Accounts/User", _tmp10_, NULL);
					_tmp12_ = _tmp11_;
					_tmp13_ = (ClickASUser*) g_initable_new (CLICK_TYPE_AS_USER_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.freedesktop.Accounts.User", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", _tmp12_, "g-interface-name", "org.freedesktop.Accounts.User", NULL);
					_tmp14_ = (ClickASUser*) _tmp13_;
					_g_free0 (_tmp12_);
					_g_free0 (_tmp10_);
					asUser = _tmp14_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						click_logind_user_destroy (&user);
						users = (_vala_ClickLogindUser_array_free (users, users_length1), NULL);
						_g_object_unref0 (logind);
						goto __catch0_g_error;
					}
					_tmp15_ = asUser;
					_tmp16_ = click_as_user_get_system_account (_tmp15_);
					_tmp17_ = _tmp16_;
					if (!_tmp17_) {
						ClickLogindUser _tmp18_;
						const gchar* _tmp19_;
						gchar* _tmp20_;
						_tmp18_ = user;
						_tmp19_ = _tmp18_.name;
						_tmp20_ = g_strdup (_tmp19_);
						_vala_array_add12 (&logged_in_users, &logged_in_users_length1, &_logged_in_users_size_, _tmp20_);
					}
					_g_object_unref0 (asUser);
					click_logind_user_destroy (&user);
				}
			}
		}
		users = (_vala_ClickLogindUser_array_free (users, users_length1), NULL);
		_g_object_unref0 (logind);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp21_ = e;
		_tmp22_ = _tmp21_->message;
		_tmp23_ = string_to_string (_tmp22_);
		_tmp24_ = g_strconcat ("Can not connect to logind or AccountsService: ", _tmp23_, NULL);
		_tmp25_ = _tmp24_;
		g_warning ("user.vala:646: %s", _tmp25_);
		_g_free0 (_tmp25_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		logged_in_users = (_vala_array_free (logged_in_users, logged_in_users_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp26_ = logged_in_users;
	_tmp26__length1 = logged_in_users_length1;
	if (result_length1) {
		*result_length1 = _tmp26__length1;
	}
	result = _tmp26_;
	return result;
}

static void
click_user_run_user_install_hooks_for_all_logged_in_users (ClickUser* self,
                                                           const gchar* package,
                                                           const gchar* old_version,
                                                           const gchar* version,
                                                           GError** error)
{
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (package != NULL);
	g_return_if_fail (version != NULL);
	_tmp1_ = click_user_get_logged_in_users (self, &_tmp0_);
	{
		gchar** username_collection = NULL;
		gint username_collection_length1 = 0;
		gint _username_collection_size_ = 0;
		gint username_it = 0;
		username_collection = _tmp1_;
		username_collection_length1 = _tmp0_;
		for (username_it = 0; username_it < username_collection_length1; username_it = username_it + 1) {
			gchar* _tmp2_;
			gchar* username = NULL;
			_tmp2_ = g_strdup (username_collection[username_it]);
			username = _tmp2_;
			{
				ClickDB* _tmp3_;
				const gchar* _tmp4_;
				_tmp3_ = self->priv->_db;
				_tmp4_ = username;
				click_package_install_hooks (_tmp3_, package, old_version, version, _tmp4_, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == G_IO_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_g_free0 (username);
						username_collection = (_vala_array_free (username_collection, username_collection_length1, (GDestroyNotify) g_free), NULL);
						return;
					} else {
						_g_free0 (username);
						username_collection = (_vala_array_free (username_collection, username_collection_length1, (GDestroyNotify) g_free), NULL);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_g_free0 (username);
			}
		}
		username_collection = (_vala_array_free (username_collection, username_collection_length1, (GDestroyNotify) g_free), NULL);
	}
}

static void
click_user_run_user_remove_hooks_for_all_logged_in_users (ClickUser* self,
                                                          const gchar* package,
                                                          const gchar* old_version,
                                                          GError** error)
{
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (package != NULL);
	g_return_if_fail (old_version != NULL);
	_tmp1_ = click_user_get_logged_in_users (self, &_tmp0_);
	{
		gchar** username_collection = NULL;
		gint username_collection_length1 = 0;
		gint _username_collection_size_ = 0;
		gint username_it = 0;
		username_collection = _tmp1_;
		username_collection_length1 = _tmp0_;
		for (username_it = 0; username_it < username_collection_length1; username_it = username_it + 1) {
			gchar* _tmp2_;
			gchar* username = NULL;
			_tmp2_ = g_strdup (username_collection[username_it]);
			username = _tmp2_;
			{
				ClickDB* _tmp3_;
				const gchar* _tmp4_;
				_tmp3_ = self->priv->_db;
				_tmp4_ = username;
				click_package_remove_hooks (_tmp3_, package, old_version, _tmp4_, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == G_IO_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_g_free0 (username);
						username_collection = (_vala_array_free (username_collection, username_collection_length1, (GDestroyNotify) g_free), NULL);
						return;
					} else {
						_g_free0 (username);
						username_collection = (_vala_array_free (username_collection, username_collection_length1, (GDestroyNotify) g_free), NULL);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_g_free0 (username);
			}
		}
		username_collection = (_vala_array_free (username_collection, username_collection_length1, (GDestroyNotify) g_free), NULL);
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static gchar*
click_user_get_dbus_session_bus_env_for_current_user (ClickUser* self)
{
	gchar* euid = NULL;
	gchar* _tmp0_;
	gchar* dbus_session_file = NULL;
	gchar* _tmp1_;
	gchar* session_env = NULL;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup_printf ("%i", (gint) geteuid ());
	euid = _tmp0_;
	_tmp1_ = g_build_filename ("/run", "user", euid, "dbus-session", NULL);
	dbus_session_file = _tmp1_;
	{
		gchar* _tmp2_ = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		g_file_get_contents (dbus_session_file, &_tmp2_, NULL, &_inner_error0_);
		_g_free0 (session_env);
		session_env = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp3_ = session_env;
		_tmp4_ = string_strip (_tmp3_);
		_g_free0 (session_env);
		session_env = _tmp4_;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		g_warning ("user.vala:681: Can not get the dbus session to stop app (%s)", _tmp6_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (session_env);
		_g_free0 (dbus_session_file);
		_g_free0 (euid);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = session_env;
	_g_free0 (dbus_session_file);
	_g_free0 (euid);
	return result;
}

static void
_vala_array_add13 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gboolean
click_user_stop_single_app (ClickUser* self,
                            const gchar* app_id)
{
	gchar** envp = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint envp_length1;
	gint _envp_size_;
	gchar* _tmp2_;
	gchar** command = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gint command_length1;
	gint _command_size_;
	gboolean res = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (app_id != NULL, FALSE);
	_tmp1_ = _tmp0_ = g_get_environ ();
	envp = _tmp1_;
	envp_length1 = _vala_array_length (_tmp0_);
	_envp_size_ = envp_length1;
	_tmp2_ = click_user_get_dbus_session_bus_env_for_current_user (self);
	_vala_array_add13 (&envp, &envp_length1, &_envp_size_, _tmp2_);
	_tmp3_ = g_strdup ("lomiri-app-stop");
	_tmp4_ = g_strdup (app_id);
	_tmp5_ = g_new0 (gchar*, 2 + 1);
	_tmp5_[0] = _tmp3_;
	_tmp5_[1] = _tmp4_;
	command = _tmp5_;
	command_length1 = 2;
	_command_size_ = command_length1;
	res = FALSE;
	{
		gint exit_status = 0;
		gchar** _tmp6_;
		gint _tmp6__length1;
		gchar** _tmp7_;
		gint _tmp7__length1;
		gint _tmp8_ = 0;
		gboolean _tmp9_ = FALSE;
		_tmp6_ = command;
		_tmp6__length1 = command_length1;
		_tmp7_ = envp;
		_tmp7__length1 = envp_length1;
		g_spawn_sync (NULL, _tmp6_, _tmp7_, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, NULL, &_tmp8_, &_inner_error0_);
		exit_status = _tmp8_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp9_ = g_spawn_check_exit_status (exit_status, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		res = _tmp9_;
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
		res = FALSE;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp10_ = FALSE;
		command = (_vala_array_free (command, command_length1, (GDestroyNotify) g_free), NULL);
		envp = (_vala_array_free (envp, envp_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp10_;
	}
	result = res;
	command = (_vala_array_free (command, command_length1, (GDestroyNotify) g_free), NULL);
	envp = (_vala_array_free (envp, envp_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static gpointer
_json_object_ref0 (gpointer self)
{
	return self ? json_object_ref (self) : NULL;
}

static gboolean
click_user_stop_running_apps_for_package (ClickUser* self,
                                          const gchar* package,
                                          const gchar* version)
{
	gboolean res = FALSE;
	JsonObject* manifest = NULL;
	JsonObject* _tmp4_;
	JsonObject* hooks = NULL;
	JsonObject* _tmp5_;
	JsonObject* _tmp6_;
	JsonObject* _tmp7_;
	JsonObject* _tmp8_;
	GList* _tmp9_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (package != NULL, FALSE);
	g_return_val_if_fail (version != NULL, FALSE);
	res = TRUE;
	if (!click_find_on_path ("lomiri-app-stop")) {
		result = FALSE;
		return result;
	}
	{
		JsonObject* _tmp0_ = NULL;
		JsonObject* _tmp1_;
		JsonObject* _tmp2_;
		_tmp1_ = click_user_get_manifest (self, package, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_json_object_unref0 (manifest);
		manifest = _tmp2_;
		_json_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
		g_warning ("user.vala:722: Can not get manifest for %s", package);
		result = FALSE;
		_json_object_unref0 (manifest);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp3_ = FALSE;
		_json_object_unref0 (manifest);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp3_;
	}
	_tmp4_ = manifest;
	if (!json_object_has_member (_tmp4_, "hooks")) {
		g_warning ("user.vala:727: No hooks in manifest %s", package);
		result = FALSE;
		_json_object_unref0 (manifest);
		return result;
	}
	_tmp5_ = manifest;
	_tmp6_ = json_object_get_object_member (_tmp5_, "hooks");
	_tmp7_ = _json_object_ref0 (_tmp6_);
	hooks = _tmp7_;
	_tmp8_ = hooks;
	_tmp9_ = json_object_get_members (_tmp8_);
	{
		GList* app_name_collection = NULL;
		GList* app_name_it = NULL;
		app_name_collection = _tmp9_;
		for (app_name_it = app_name_collection; app_name_it != NULL; app_name_it = app_name_it->next) {
			const gchar* app_name = NULL;
			app_name = (const gchar*) app_name_it->data;
			{
				const gchar* _tmp10_;
				const gchar* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				_tmp10_ = string_to_string (package);
				_tmp11_ = app_name;
				_tmp12_ = string_to_string (_tmp11_);
				_tmp13_ = string_to_string (version);
				_tmp14_ = g_strconcat (_tmp10_, "_", _tmp12_, "_", _tmp13_, NULL);
				_tmp15_ = _tmp14_;
				res &= click_user_stop_single_app (self, _tmp15_);
				_g_free0 (_tmp15_);
			}
		}
		(app_name_collection == NULL) ? NULL : (app_name_collection = (g_list_free (app_name_collection), NULL));
	}
	result = res;
	_json_object_unref0 (hooks);
	_json_object_unref0 (manifest);
	return result;
}

static void
click_user_package_remove_user_cache (ClickUser* self,
                                      const gchar* package,
                                      GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (package != NULL);
	click_user_drop_privileges (self, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
	{
		gchar* path = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* file = NULL;
		const gchar* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		_tmp0_ = g_get_user_cache_dir ();
		_tmp1_ = g_build_filename (_tmp0_, package, NULL);
		path = _tmp1_;
		_tmp2_ = path;
		_tmp3_ = g_file_new_for_path (_tmp2_);
		file = _tmp3_;
		_tmp4_ = file;
		click_rmtree (_tmp4_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (file);
			_g_free0 (path);
			goto __catch0_g_error;
		}
		_g_object_unref0 (file);
		_g_free0 (path);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		g_warning ("user.vala:746: Error removing cache for '%s': %s", package, _tmp6_);
		_g_error_free0 (e);
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
		click_user_regain_privileges (self);
	}
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
}

/**
 * remove:
 * @package: A package name.
 *
 * Remove this user's registration of @package.
 */
void
click_user_remove (ClickUser* self,
                   const gchar* package,
                   GError** error)
{
	gchar* user_db = NULL;
	gchar* _tmp0_;
	gchar* path = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* old_version = NULL;
	const gchar* _tmp3_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	const gchar* _tmp22_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (package != NULL);
	_tmp0_ = click_user_get_overlay_db (self);
	user_db = _tmp0_;
	_tmp1_ = user_db;
	_tmp2_ = g_build_filename (_tmp1_, package, NULL);
	path = _tmp2_;
	_tmp3_ = path;
	if (click_user_is_valid_link (self, _tmp3_)) {
		gchar* target = NULL;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp4_ = path;
		_tmp5_ = g_file_read_link (_tmp4_, &_inner_error0_);
		target = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (old_version);
			_g_free0 (path);
			_g_free0 (user_db);
			return;
		}
		_tmp6_ = target;
		_tmp7_ = g_path_get_basename (_tmp6_);
		_g_free0 (old_version);
		old_version = _tmp7_;
		click_user_drop_privileges (self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (target);
			_g_free0 (old_version);
			_g_free0 (path);
			_g_free0 (user_db);
			return;
		}
		{
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			_tmp8_ = old_version;
			click_user_stop_running_apps_for_package (self, package, _tmp8_);
			_tmp9_ = path;
			click_unlink_force (_tmp9_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __finally0;
			}
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			click_user_regain_privileges (self);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (target);
			_g_free0 (old_version);
			_g_free0 (path);
			_g_free0 (user_db);
			return;
		}
		_g_free0 (target);
	} else {
		{
			gchar* _tmp10_ = NULL;
			gchar* _tmp11_;
			gchar* _tmp12_;
			_tmp11_ = click_user_get_version (self, package, &_inner_error0_);
			_tmp10_ = _tmp11_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == CLICK_USER_ERROR) {
					goto __catch1_click_user_error;
				}
				_g_free0 (old_version);
				_g_free0 (path);
				_g_free0 (user_db);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_tmp12_ = _tmp10_;
			_tmp10_ = NULL;
			_g_free0 (old_version);
			old_version = _tmp12_;
			_g_free0 (_tmp10_);
		}
		goto __finally1;
		__catch1_click_user_error:
		{
			const gchar* _tmp13_;
			GError* _tmp14_;
			g_clear_error (&_inner_error0_);
			_tmp13_ = self->priv->_name;
			_tmp14_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_NO_SUCH_PACKAGE, "%s does not exist in any database " "for user %s", package, _tmp13_);
			_inner_error0_ = _tmp14_;
			goto __finally1;
		}
		__finally1:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (old_version);
			_g_free0 (path);
			_g_free0 (user_db);
			return;
		}
		click_user_ensure_db (self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (old_version);
			_g_free0 (path);
			_g_free0 (user_db);
			return;
		}
		click_user_drop_privileges (self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (old_version);
			_g_free0 (path);
			_g_free0 (user_db);
			return;
		}
		{
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			_tmp15_ = old_version;
			click_user_stop_running_apps_for_package (self, package, _tmp15_);
			_tmp16_ = path;
			click_symlink_force (CLICK_HIDDEN_VERSION, _tmp16_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __finally2;
			}
		}
		__finally2:
		{
			GError* _inner_error1_ = NULL;
			click_user_regain_privileges (self);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (old_version);
			_g_free0 (path);
			_g_free0 (user_db);
			return;
		}
	}
	_tmp17_ = click_user_get_is_pseudo_user (self);
	_tmp18_ = _tmp17_;
	if (!_tmp18_) {
		ClickDB* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		_tmp19_ = self->priv->_db;
		_tmp20_ = old_version;
		_tmp21_ = self->priv->_name;
		click_package_remove_hooks (_tmp19_, package, _tmp20_, _tmp21_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (old_version);
			_g_free0 (path);
			_g_free0 (user_db);
			return;
		}
		click_user_package_remove_user_cache (self, package, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (old_version);
			_g_free0 (path);
			_g_free0 (user_db);
			return;
		}
	}
	_tmp22_ = self->priv->_name;
	if (g_strcmp0 (_tmp22_, CLICK_ALL_USERS) == 0) {
		const gchar* _tmp23_;
		_tmp23_ = old_version;
		click_user_run_user_remove_hooks_for_all_logged_in_users (self, package, _tmp23_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (old_version);
			_g_free0 (path);
			_g_free0 (user_db);
			return;
		}
	}
	_g_free0 (old_version);
	_g_free0 (path);
	_g_free0 (user_db);
}

/**
 * get_path:
 * @package: A package name.
 *
 * Returns: The path at which @package is registered for this user.
 */
gchar*
click_user_get_path (ClickUser* self,
                     const gchar* package,
                     GError** error)
{
	const gchar* _tmp29_;
	GError* _tmp30_;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (package != NULL, NULL);
	{
		gint i = 0;
		ClickDB* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		_tmp0_ = self->priv->_db;
		_tmp1_ = click_db_get_size (_tmp0_);
		_tmp2_ = _tmp1_;
		i = _tmp2_ - 1;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				ClickSingleDB* _tmp5_ = NULL;
				ClickDB* _tmp6_;
				ClickSingleDB* _tmp7_;
				gchar* user_db = NULL;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* path = NULL;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				const gchar* _tmp14_;
				ClickSingleDB* _tmp18_ = NULL;
				ClickDB* _tmp19_;
				ClickSingleDB* _tmp20_;
				gchar* all_users_db = NULL;
				const gchar* _tmp21_;
				const gchar* _tmp22_;
				gchar* _tmp23_;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				const gchar* _tmp26_;
				if (!_tmp3_) {
					gint _tmp4_;
					i = i - 1;
					_tmp4_ = i;
				}
				_tmp3_ = FALSE;
				if (!(i >= 0)) {
					break;
				}
				_tmp6_ = self->priv->_db;
				_tmp7_ = click_db_get (_tmp6_, i, &_inner_error0_);
				_tmp5_ = _tmp7_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == CLICK_USER_ERROR) {
						g_propagate_error (error, _inner_error0_);
						return NULL;
					} else {
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp8_ = click_single_db_get_root (_tmp5_);
				_tmp9_ = _tmp8_;
				_tmp10_ = self->priv->_name;
				_tmp11_ = click_db_for_user (_tmp9_, _tmp10_);
				user_db = _tmp11_;
				_tmp12_ = user_db;
				_tmp13_ = g_build_filename (_tmp12_, package, NULL);
				path = _tmp13_;
				_tmp14_ = path;
				if (click_user_is_valid_link (self, _tmp14_)) {
					result = path;
					_g_free0 (user_db);
					_g_object_unref0 (_tmp5_);
					return result;
				} else {
					const gchar* _tmp15_;
					_tmp15_ = path;
					if (click_is_symlink (_tmp15_)) {
						const gchar* _tmp16_;
						GError* _tmp17_;
						_tmp16_ = self->priv->_name;
						_tmp17_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_HIDDEN_PACKAGE, "%s is hidden for user %s", package, _tmp16_);
						_inner_error0_ = _tmp17_;
						if (_inner_error0_->domain == CLICK_USER_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_g_free0 (path);
							_g_free0 (user_db);
							_g_object_unref0 (_tmp5_);
							return NULL;
						} else {
							_g_free0 (path);
							_g_free0 (user_db);
							_g_object_unref0 (_tmp5_);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return NULL;
						}
					}
				}
				_tmp19_ = self->priv->_db;
				_tmp20_ = click_db_get (_tmp19_, i, &_inner_error0_);
				_tmp18_ = _tmp20_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == CLICK_USER_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_g_free0 (path);
						_g_free0 (user_db);
						_g_object_unref0 (_tmp5_);
						return NULL;
					} else {
						_g_free0 (path);
						_g_free0 (user_db);
						_g_object_unref0 (_tmp5_);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp21_ = click_single_db_get_root (_tmp18_);
				_tmp22_ = _tmp21_;
				_tmp23_ = click_db_for_user (_tmp22_, CLICK_ALL_USERS);
				all_users_db = _tmp23_;
				_tmp24_ = all_users_db;
				_tmp25_ = g_build_filename (_tmp24_, package, NULL);
				_g_free0 (path);
				path = _tmp25_;
				_tmp26_ = path;
				if (click_user_is_valid_link (self, _tmp26_)) {
					result = path;
					_g_free0 (all_users_db);
					_g_object_unref0 (_tmp18_);
					_g_free0 (user_db);
					_g_object_unref0 (_tmp5_);
					return result;
				} else {
					const gchar* _tmp27_;
					_tmp27_ = path;
					if (click_is_symlink (_tmp27_)) {
						GError* _tmp28_;
						_tmp28_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_HIDDEN_PACKAGE, "%s is hidden for all users", package);
						_inner_error0_ = _tmp28_;
						if (_inner_error0_->domain == CLICK_USER_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_g_free0 (all_users_db);
							_g_object_unref0 (_tmp18_);
							_g_free0 (path);
							_g_free0 (user_db);
							_g_object_unref0 (_tmp5_);
							return NULL;
						} else {
							_g_free0 (all_users_db);
							_g_object_unref0 (_tmp18_);
							_g_free0 (path);
							_g_free0 (user_db);
							_g_object_unref0 (_tmp5_);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return NULL;
						}
					}
				}
				_g_free0 (all_users_db);
				_g_object_unref0 (_tmp18_);
				_g_free0 (path);
				_g_free0 (user_db);
				_g_object_unref0 (_tmp5_);
			}
		}
	}
	_tmp29_ = self->priv->_name;
	_tmp30_ = g_error_new (CLICK_USER_ERROR, CLICK_USER_ERROR_NO_SUCH_PACKAGE, "%s does not exist in any database for user %s", package, _tmp29_);
	_inner_error0_ = _tmp30_;
	if (_inner_error0_->domain == CLICK_USER_ERROR) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	} else {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

/**
 * get_manifest:
 * @package: A package name.
 *
 * Returns: A #Json.Object containing a package's manifest.
 *
 * Since: 0.4.18
 */
JsonObject*
click_user_get_manifest (ClickUser* self,
                         const gchar* package,
                         GError** error)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	JsonObject* obj = NULL;
	ClickDB* _tmp2_;
	JsonObject* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	JsonObject* _tmp6_;
	gint _tmp7_ = 0;
	JsonObject* _tmp8_;
	GError* _inner_error0_ = NULL;
	JsonObject* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (package != NULL, NULL);
	_tmp1_ = click_user_get_version (self, package, &_inner_error0_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	_tmp2_ = self->priv->_db;
	_tmp3_ = click_db_get_manifest (_tmp2_, package, _tmp0_, &_inner_error0_);
	obj = _tmp3_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (_tmp0_);
		return NULL;
	}
	_tmp5_ = click_user_get_path (self, package, &_inner_error0_);
	_tmp4_ = _tmp5_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_json_object_unref0 (obj);
		_g_free0 (_tmp0_);
		return NULL;
	}
	_tmp6_ = obj;
	json_object_set_string_member (_tmp6_, "_directory", _tmp4_);
	if (click_user_is_removable (self, package)) {
		_tmp7_ = 1;
	} else {
		_tmp7_ = 0;
	}
	_tmp8_ = obj;
	json_object_set_int_member (_tmp8_, "_removable", (gint64) _tmp7_);
	result = obj;
	_g_free0 (_tmp4_);
	_g_free0 (_tmp0_);
	return result;
}

/**
 * get_manifest_as_string:
 * @package: A package name.
 *
 * Returns: A JSON string containing a package's serialised
 * manifest.
 * This interface may be useful for clients with their own JSON
 * parsing tools that produce representations more convenient for
 * them.
 *
 * Since: 0.4.21
 */
static void
_vala_JsonNode_free (JsonNode* self)
{
	g_boxed_free (json_node_get_type (), self);
}

gchar*
click_user_get_manifest_as_string (ClickUser* self,
                                   const gchar* package,
                                   GError** error)
{
	JsonObject* manifest = NULL;
	JsonObject* _tmp0_;
	JsonNode* node = NULL;
	JsonNode* _tmp1_;
	JsonNode* _tmp2_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp3_;
	JsonGenerator* _tmp4_;
	JsonNode* _tmp5_;
	JsonGenerator* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (package != NULL, NULL);
	_tmp0_ = click_user_get_manifest (self, package, &_inner_error0_);
	manifest = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	_tmp1_ = json_node_new (JSON_NODE_OBJECT);
	node = _tmp1_;
	_tmp2_ = node;
	json_node_set_object (_tmp2_, manifest);
	_tmp3_ = json_generator_new ();
	generator = _tmp3_;
	_tmp4_ = generator;
	_tmp5_ = node;
	json_generator_set_root (_tmp4_, _tmp5_);
	_tmp6_ = generator;
	_tmp7_ = json_generator_to_data (_tmp6_, NULL);
	result = _tmp7_;
	_g_object_unref0 (generator);
	__vala_JsonNode_free0 (node);
	_json_object_unref0 (manifest);
	return result;
}

/**
 * get_manifests:
 *
 * Returns: A #Json.Array containing manifests of all packages
 * registered for this user.  The manifest may include additional
 * dynamic keys (starting with an underscore) corresponding to
 * dynamic properties of installed packages.
 *
 * Since: 0.4.18
 */
JsonArray*
click_user_get_manifests (ClickUser* self,
                          GError** error)
{
	JsonArray* ret = NULL;
	JsonArray* _tmp0_;
	GList* _tmp1_ = NULL;
	GList* _tmp2_;
	GError* _inner_error0_ = NULL;
	JsonArray* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = json_array_new ();
	ret = _tmp0_;
	_tmp2_ = click_user_get_package_names (self, &_inner_error0_);
	_tmp1_ = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_json_array_unref0 (ret);
		return NULL;
	}
	{
		GList* package_collection = NULL;
		GList* package_it = NULL;
		package_collection = _tmp1_;
		for (package_it = package_collection; package_it != NULL; package_it = package_it->next) {
			gchar* _tmp3_;
			gchar* package = NULL;
			_tmp3_ = g_strdup ((const gchar*) package_it->data);
			package = _tmp3_;
			{
				{
					JsonObject* _tmp4_ = NULL;
					const gchar* _tmp5_;
					JsonObject* _tmp6_;
					JsonObject* _tmp7_;
					_tmp5_ = package;
					_tmp6_ = click_user_get_manifest (self, _tmp5_, &_inner_error0_);
					_tmp4_ = _tmp6_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch0_g_error;
					}
					_tmp7_ = _tmp4_;
					_tmp4_ = NULL;
					json_array_add_object_element (ret, _tmp7_);
					_json_object_unref0 (_tmp4_);
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp8_;
					const gchar* _tmp9_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp8_ = e;
					_tmp9_ = _tmp8_->message;
					g_warning ("user.vala:904: %s", _tmp9_);
					_g_error_free0 (e);
				}
				__finally0:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_free0 (package);
					(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__g_free0_ (_tmp1_), NULL));
					_json_array_unref0 (ret);
					return NULL;
				}
				_g_free0 (package);
			}
		}
	}
	result = ret;
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__g_free0_ (_tmp1_), NULL));
	return result;
}

/**
 * get_manifests_as_string:
 *
 * Returns: A JSON string containing a serialised array of manifests
 * of all packages registered for this user.  The manifest may
 * include additional dynamic keys (starting with an underscore)
 * corresponding to dynamic properties of installed packages.
 * This interface may be useful for clients with their own JSON
 * parsing tools that produce representations more convenient for
 * them.
 *
 * Since: 0.4.21
 */
gchar*
click_user_get_manifests_as_string (ClickUser* self,
                                    GError** error)
{
	JsonArray* manifests = NULL;
	JsonArray* _tmp0_;
	JsonNode* node = NULL;
	JsonNode* _tmp1_;
	JsonNode* _tmp2_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp3_;
	JsonGenerator* _tmp4_;
	JsonNode* _tmp5_;
	JsonGenerator* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = click_user_get_manifests (self, &_inner_error0_);
	manifests = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	_tmp1_ = json_node_new (JSON_NODE_ARRAY);
	node = _tmp1_;
	_tmp2_ = node;
	json_node_set_array (_tmp2_, manifests);
	_tmp3_ = json_generator_new ();
	generator = _tmp3_;
	_tmp4_ = generator;
	_tmp5_ = node;
	json_generator_set_root (_tmp4_, _tmp5_);
	_tmp6_ = generator;
	_tmp7_ = json_generator_to_data (_tmp6_, NULL);
	result = _tmp7_;
	_g_object_unref0 (generator);
	__vala_JsonNode_free0 (node);
	_json_array_unref0 (manifests);
	return result;
}

/**
 * is_removable:
 * @package: A package name.
 *
 * Returns: True if @package is removable for this user, otherwise
 * False.
 */
gboolean
click_user_is_removable (ClickUser* self,
                         const gchar* package)
{
	gchar* user_db = NULL;
	gchar* _tmp0_;
	gchar* path = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* all_users_db = NULL;
	ClickDB* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (package != NULL, FALSE);
	_tmp0_ = click_user_get_overlay_db (self);
	user_db = _tmp0_;
	_tmp1_ = user_db;
	_tmp2_ = g_build_filename (_tmp1_, package, NULL);
	path = _tmp2_;
	_tmp3_ = path;
	if (click_exists (_tmp3_)) {
		result = TRUE;
		_g_free0 (path);
		_g_free0 (user_db);
		return result;
	} else {
		const gchar* _tmp4_;
		_tmp4_ = path;
		if (click_is_symlink (_tmp4_)) {
			result = FALSE;
			_g_free0 (path);
			_g_free0 (user_db);
			return result;
		}
	}
	_tmp5_ = self->priv->_db;
	_tmp6_ = click_db_get_overlay (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = click_db_for_user (_tmp7_, CLICK_ALL_USERS);
	all_users_db = _tmp8_;
	_tmp9_ = all_users_db;
	_tmp10_ = g_build_filename (_tmp9_, package, NULL);
	_g_free0 (path);
	path = _tmp10_;
	_tmp11_ = path;
	if (click_user_is_valid_link (self, _tmp11_)) {
		result = TRUE;
		_g_free0 (all_users_db);
		_g_free0 (path);
		_g_free0 (user_db);
		return result;
	} else {
		const gchar* _tmp12_;
		_tmp12_ = path;
		if (click_is_symlink (_tmp12_)) {
			result = FALSE;
			_g_free0 (all_users_db);
			_g_free0 (path);
			_g_free0 (user_db);
			return result;
		}
	}
	if (click_user_has_package_name (self, package)) {
		result = TRUE;
		_g_free0 (all_users_db);
		_g_free0 (path);
		_g_free0 (user_db);
		return result;
	} else {
		result = FALSE;
		_g_free0 (all_users_db);
		_g_free0 (path);
		_g_free0 (user_db);
		return result;
	}
}

static ClickDB*
click_user_get_db (ClickUser* self)
{
	ClickDB* result;
	ClickDB* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_db;
	result = _tmp0_;
	return result;
}

static void
click_user_set_db (ClickUser* self,
                   ClickDB* value)
{
	ClickDB* old_value;
	g_return_if_fail (self != NULL);
	old_value = click_user_get_db (self);
	if (old_value != value) {
		ClickDB* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_db);
		self->priv->_db = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, click_user_properties[CLICK_USER_DB_PROPERTY]);
	}
}

static const gchar*
click_user_get_name (ClickUser* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

static void
click_user_set_name (ClickUser* self,
                     const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = click_user_get_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, click_user_properties[CLICK_USER_NAME_PROPERTY]);
	}
}

gboolean
click_user_get_is_pseudo_user (ClickUser* self)
{
	gboolean result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_name;
	result = g_str_has_prefix (_tmp0_, "@");
	return result;
}

gboolean
click_user_get_is_gc_in_use (ClickUser* self)
{
	gboolean result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_name;
	result = g_strcmp0 (_tmp0_, CLICK_GC_IN_USE_USER) == 0;
	return result;
}

static void
click_user_class_init (ClickUserClass * klass,
                       gpointer klass_data)
{
	click_user_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ClickUser_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_click_user_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_click_user_set_property;
	G_OBJECT_CLASS (klass)->finalize = click_user_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLICK_USER_DB_PROPERTY, click_user_properties[CLICK_USER_DB_PROPERTY] = g_param_spec_object ("db", "db", "db", CLICK_TYPE_DB, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLICK_USER_NAME_PROPERTY, click_user_properties[CLICK_USER_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	 * True if and only if this user is a pseudo-user.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLICK_USER_IS_PSEUDO_USER_PROPERTY, click_user_properties[CLICK_USER_IS_PSEUDO_USER_PROPERTY] = g_param_spec_boolean ("is-pseudo-user", "is-pseudo-user", "is-pseudo-user", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	 * True if and only if this user is the pseudo-user indicating that
	 * a registration was in use at the time of package removal.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLICK_USER_IS_GC_IN_USE_PROPERTY, click_user_properties[CLICK_USER_IS_GC_IN_USE_PROPERTY] = g_param_spec_boolean ("is-gc-in-use", "is-gc-in-use", "is-gc-in-use", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
click_user_instance_init (ClickUser * self,
                          gpointer klass)
{
	self->priv = click_user_get_instance_private (self);
}

static void
click_user_finalize (GObject * obj)
{
	ClickUser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLICK_TYPE_USER, ClickUser);
	_g_object_unref0 (self->priv->_db);
	_g_free0 (self->priv->_name);
	_g_object_unref0 (self->priv->users);
	_g_object_unref0 (self->priv->user_pw);
	_g_free0 (self->priv->old_umask);
	G_OBJECT_CLASS (click_user_parent_class)->finalize (obj);
}

static GType
click_user_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClickUserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) click_user_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClickUser), 0, (GInstanceInitFunc) click_user_instance_init, NULL };
	GType click_user_type_id;
	click_user_type_id = g_type_register_static (G_TYPE_OBJECT, "ClickUser", &g_define_type_info, 0);
	ClickUser_private_offset = g_type_add_instance_private (click_user_type_id, sizeof (ClickUserPrivate));
	return click_user_type_id;
}

GType
click_user_get_type (void)
{
	static volatile gsize click_user_type_id__once = 0;
	if (g_once_init_enter (&click_user_type_id__once)) {
		GType click_user_type_id;
		click_user_type_id = click_user_get_type_once ();
		g_once_init_leave (&click_user_type_id__once, click_user_type_id);
	}
	return click_user_type_id__once;
}

static void
_vala_click_user_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	ClickUser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CLICK_TYPE_USER, ClickUser);
	switch (property_id) {
		case CLICK_USER_DB_PROPERTY:
		g_value_set_object (value, click_user_get_db (self));
		break;
		case CLICK_USER_NAME_PROPERTY:
		g_value_set_string (value, click_user_get_name (self));
		break;
		case CLICK_USER_IS_PSEUDO_USER_PROPERTY:
		g_value_set_boolean (value, click_user_get_is_pseudo_user (self));
		break;
		case CLICK_USER_IS_GC_IN_USE_PROPERTY:
		g_value_set_boolean (value, click_user_get_is_gc_in_use (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_click_user_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	ClickUser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CLICK_TYPE_USER, ClickUser);
	switch (property_id) {
		case CLICK_USER_DB_PROPERTY:
		click_user_set_db (self, g_value_get_object (value));
		break;
		case CLICK_USER_NAME_PROPERTY:
		click_user_set_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

